/******************************************************************************
 * g3DGMV
 * Copyright (C) <1999> <Nick Yost>
 *-----------------------------------------------------------------------------
 *  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ******************************************************************************/

#include <config.h>
#include <gnome.h>
#include <gdk_imlib.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "world.h"
#include "menus.h"
#include "popup.h"
#include "g3DGMVsig.h"
#include "g3DGMVsrc.h"
/* used for  DEM converter */
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/errno.h>
#include "LatLong-UTMconversion.h"
//#include "draw_entry.h"


static GSList* app_list = NULL;

/* --Global-- */
GtkWidget *win_main;
GtkWidget *popup_menu=NULL; 
GtkAccelGroup *accel_group = NULL;

static gint drawtype_press_event = 0;
static gint drawtype_release_event = 1;
gint drawtype_motion_event = 2;


static gdouble Wlast_x = 100;
static gdouble Wlast_y = 100;
static gboolean right_button_event = FALSE,
       NormalMode=TRUE,
       MapColor=FALSE;

// wire frame mode step size
gint Step=1;
gint FrameWidth =100; 
gint FrameHeight=100;
double Ax=0,Ay=0,Az=0;
gint EnableSetupFlag = TRUE;

GtkWidget *text2;
int File2_stat = FALSE;

char *filein;
static GdkPixmap *bkpixmap = NULL;

GdkImlibImage *im=NULL;
gint imw,imh,endoflist;
float imsize=1, flipH=0,flipV=0,rot=0;
GtkWidget *statusbar3;
GtkWidget *drawingarea2; 
GtkWidget *progress_bar;
ElevMap *Map = (ElevMap *)NULL;
static gboolean mouse_button_pressed =FALSE;


/******************************************************************************
 * Name:         expose_event
 *-----------------------------------------------------------------------------
 * Description: When the window the gdk_widget_darw routine is called, this
 *              routine is caled. It copies the background pixmap to the 
 *              window.
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - a drawable area
 *    event  - 
 ******************************************************************************/
static gint
expose_event                           (GtkWidget    *widget,
                                        GdkEventExpose     *event)
{
  GtkWidget *colorarea;
  colorarea =get_widget ((GtkWidget *) win_main, "colorarea");

  /* copy pixmap to the window */
  gdk_draw_pixmap(widget->window,
		  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		  bkpixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, event->area.height);

  /* copy the last selected color to the color area */
  gdk_draw_rectangle (colorarea->window,
		      newgc,
		      TRUE,
		      0,0,
		      colorarea->allocation.width,
		      colorarea->allocation.height);
  return FALSE;
}


/******************************************************************************
 * Name:        configure_event
 *-----------------------------------------------------------------------------
 * Description: Create a new backing pixmap of the appropriate size. This get 
 *              called whenever the window is resized
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - a drawable area
 *    event  - a configuration event such changing the  window size.
 ******************************************************************************/
static gint
configure_event                        (GtkWidget    *widget,
                                        GdkEventConfigure     *event)
{
  GtkWidget *colorarea;
  GtkWidget *check_line;
  colorarea =get_widget ((GtkWidget *) win_main, "colorarea");
  check_line  = get_widget ((GtkWidget *) win_main, "glade_menuitem4");

  /* Free background if we created it..*/
  if (bkpixmap)
    gdk_pixmap_unref(bkpixmap);
  
  /* Create a new pixmap with new size */
  bkpixmap = gdk_pixmap_new(widget->window,
			    widget->allocation.width,
			    widget->allocation.height,
			    -1);

  if (Map->pixmap == NULL)
  {
    /* initilize map colors.*/
    Initilize_map( widget->window);
    /* set bkpixmap color to black*/
    gdk_draw_rectangle (bkpixmap,
    			widget->style->white_gc,
    			TRUE,
    			0, 0,
    			widget->allocation.width,
    			widget->allocation.height);
  }
  else  if(drawtype_motion_event == 15 || drawtype_motion_event == 14) 
  {
    if (GTK_CHECK_MENU_ITEM( check_line)->active)
      Generate_Wire_frame(Map,bkpixmap,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step,Ax,Ay,Az,0,MapColor,(float)imsize*4);
    else
      Generate_Wire_frame(Map,bkpixmap,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step,Ax,Ay,Az,1,MapColor,(float)imsize*4);
  }
  else
  {
 
    /* copy Map->pixmap to the background */
    gdk_draw_pixmap    (bkpixmap,
			widget->style->white_gc,
			Map->pixmap,
			0,0,
			0,0,
			widget->allocation.width,
			widget->allocation.height);
   }
    
   /* copy the initized color newgc to the color area */
   gdk_draw_rectangle (colorarea->window,
		       newgc,
		       TRUE,
		       0,0,
		       colorarea->allocation.width,
		       colorarea->allocation.height);
 
  return TRUE;
}

/******************************************************************************
 * Name:        delete_event 
 *-----------------------------------------------------------------------------
 * Description: clean up and close the g3DGMV application.
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - calling wiget
 *    data - unused.  
 ******************************************************************************/
gint 
delete_event                           (GtkWidget *widget,
					GdkEvent *event, gpointer data)
{
  gdk_imlib_free_pixmap(Map->pixmap);
  gdk_imlib_kill_image(im); im=NULL;
  gtk_main_quit ();
  return(FALSE);
}

/******************************************************************************
 * Name:        delete_event 
 *-----------------------------------------------------------------------------
 * Description: A house keeping function (simply returns a pointer the 
 *              elevation map) will be deleted in the future.
 ******************************************************************************/
ElevMap *getmap()
  {return Map;}

/******************************************************************************
 * Name:        push_item
 *-----------------------------------------------------------------------------
 * Description: this function push a text string to the status bar.
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - a drawable area
 *    data - the string to print in the status bar.  
 ******************************************************************************/
void 
push_item                               (GtkWidget    *widget,
					 char* data)
{ 
 gnome_appbar_pop((GnomeAppBar *) statusbar3);
 gnome_appbar_push((GnomeAppBar *) statusbar3,data);
 
}

/******************************************************************************
 * Name:        draw_area_event
 *-----------------------------------------------------------------------------
 * Description: this sets up the mouse event sequence for the draw area. The
 *              draw area events are defined in the draw_brush function. This
 *              fuction is called from the Popup menu.
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - a drawable area
 *    button_type - popup item that called this.  
 ******************************************************************************/
void draw_area_event (GtkWidget*widget, char* button_type)
{ 
  static gboolean update= TRUE;

  if (strcmp(button_type,"1")==0){
    // set up even sequence to Draw a Rectangle on the map 
    drawtype_press_event= 0;
    drawtype_release_event= 1;
    drawtype_motion_event = 2;
    update =TRUE;}
  else if (strcmp(button_type,"2")==0){
    // set up even sequence to Draw Line on the map
    drawtype_press_event= 0;
    drawtype_release_event= 3;
    drawtype_motion_event = 4;
    update =TRUE;}
  else if (strcmp(button_type,"3")==0){
    // set up even sequence to fill a bounded area on the map
    // with a selected color
    drawtype_press_event= 0;
    drawtype_release_event= 9;
    drawtype_motion_event = 0;
    update =TRUE;}
  else if (strcmp(button_type,"4")==0){
    // set up even sequence to replace a color with another
    // color of a selected area on the map
    drawtype_press_event= 0;
    drawtype_release_event= 10;
    drawtype_motion_event = 0;
    update =TRUE;}
  else if(strcmp(button_type,"6")==0){
    // set up even sequence to Draw on map Free Hand
    drawtype_press_event= 12;
    drawtype_release_event= 5;
    drawtype_motion_event = 5;
    update =TRUE;}
  else if(strcmp(button_type,"7")==0){
    // set up even sequence to Pick Color from Map
    drawtype_press_event= 11;
    drawtype_release_event= 0;
    drawtype_motion_event = 0;
    update =TRUE;}
  else if(strcmp(button_type,"8")==0){
    // set up even sequence to Find Position on Map
    drawtype_press_event= 13;
    drawtype_release_event= 0;
    drawtype_motion_event = 0;
    update =TRUE;}
  else if(strcmp(button_type,"10")==0){
    // set up event sequence default
    drawtype_press_event= 0;
    drawtype_release_event= 0;
    drawtype_motion_event = 0;
    update =TRUE;}
  else if(strcmp(button_type,"9")==0){
    // set up event sequence for wire frame angles
    drawtype_press_event= 0;
    drawtype_release_event= 16;
    drawtype_motion_event = 14;
    if(update && Map->col_list_ptr != NULL)
    {
      if(Map->pixmap) 
      	gdk_imlib_free_pixmap(Map->pixmap);
      Resize_pixmap(Map,drawingarea2->window,FALSE);
      gtk_widget_set_usize( drawingarea2, Map->pixmap_size.x, Map->pixmap_size.y);
      update =FALSE;
      NormalMode=FALSE;
    }
  }
  else if(strcmp(button_type,"0")==0){
    // set up event sequence for wire frame move
    drawtype_press_event= 0;
    drawtype_release_event= 16;
    drawtype_motion_event = 15;
    if(update && Map->col_list_ptr != NULL)
    {
      if(Map->pixmap) 
      	gdk_imlib_free_pixmap(Map->pixmap);
      Resize_pixmap(Map,drawingarea2->window,FALSE);
      gtk_widget_set_usize(drawingarea2, Map->pixmap_size.x, Map->pixmap_size.y);
      update =FALSE;
      NormalMode=FALSE;
    }
   }
  
  else{
    // set up event sequence for rotation
    drawtype_press_event= 6;
    drawtype_release_event= 8;
    drawtype_motion_event = 7;
    NormalMode=FALSE;}
 }

/******************************************************************************
 * Name:        button_press
 *-----------------------------------------------------------------------------
 * Description: This function gets called when the a mouse right button is 
 *              press inside the drawarea. It opens the popup menu.
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - a drawable area
 *    event - normally a mouse event  
 ******************************************************************************/
static gint button_press (GtkWidget *widget, GdkEvent *event)
{

    if (event->type == GDK_BUTTON_PRESS) {
      GdkEventButton *bevent = (GdkEventButton *) event; 
      gtk_menu_popup (GTK_MENU(widget), NULL, NULL, NULL, NULL,
		      bevent->button, bevent->time);
      /* Tell calling code that we have handled this event; the buck
       * stops here. */
      return TRUE;
    }

    /* Tell calling code that we have not handled this event; pass it on. */
    return FALSE;
}

/******************************************************************************
 * Name:        on_Spinner_Changed
 *-----------------------------------------------------------------------------
 * Description: This function gets called when the any of the spiners get 
 *              changed in the Frame dialog box (see popup.c)
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    entry - the spinner button that called this function
 *    data  - a pointer to the spinners name 
 ******************************************************************************/  
void
on_Spinner_Changed (GtkSpinButton *entry, gpointer data )
{
  // check if the is frame step size has changed
  if (!strcmp(data,"spinbutton5"))                                     
    Step= gtk_spin_button_get_value_as_int(entry);
  // check if the is frame width has changed
  if (!strcmp(data,"spinbutton6"))                                     
    FrameWidth= gtk_spin_button_get_value_as_int(entry);
  // check if the is frame hieght has changed
  if (!strcmp(data,"spinbutton7"))                                     
    FrameHeight= gtk_spin_button_get_value_as_int(entry);
  // check if the is X axis rotation value has changed
  if (!strcmp(data,"spinbutton8"))                                     
    Ax= gtk_spin_button_get_value_as_int(entry);
  // check if the is Y axis rotation value has changed
  if (!strcmp(data,"spinbutton9"))                                     
    Ay= gtk_spin_button_get_value_as_int(entry);
  // check if the is Z  axis rotation value has changed
  if (!strcmp(data,"spinbutton10"))                                     
    Az= gtk_spin_button_get_value_as_int(entry);
  // check if the is Water Level value has changed
  if (!strcmp(data,"spinbutton11"))  
    map_set_water_level(Map,gtk_spin_button_get_value_as_int(entry));

  if ( Map->col_list_ptr != NULL)
  {
    if(drawtype_motion_event == 15 || drawtype_motion_event == 14)
    {
      // update map display
       Generate_DEM(win_main,0,0,0,0,1); 
    }
  }

}

/******************************************************************************
 * Name:        on_DailogFrame_activate
 *-----------------------------------------------------------------------------
 * Description: This function gets called when the custom button is clicked 
 *              in the popup menu.It creates the Frame dialog box used for
 *              customizing some map settings. (see popup.c)
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    Button - normally the custom button in the popup menu
 *    data  - not used 
 ******************************************************************************/
void on_DailogFrame_activate(GtkWidget *button, gpointer data ) 
{
  GtkWidget *Dailog_Frame;
  
  // disable the  custom button in popup menu
  gtk_widget_set_sensitive(button,FALSE);

  // now create the frame dialog box
  Dailog_Frame=create_FrameDialog(win_main);
  gtk_window_set_transient_for( GTK_WINDOW(Dailog_Frame),
				GTK_WINDOW (win_main));
  EnableSetupFlag = FALSE;  
  gtk_widget_show (Dailog_Frame);
}

/******************************************************************************
 * Name:        on_Toolbox_activate
 *-----------------------------------------------------------------------------
 * Description: This function gets called when the tool Icon is pressed 
 *              in the toolbar. It creates the widget tool dialog box used for
 *              doing thing with the mouse in the drawarea such as drawing 
 *              a colored line on the map. 
 *              (see popup.c)
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    Button - normally the custom button in the popup menu
 *    data  - not used 
 ******************************************************************************/
void on_Toolbox_activate(GtkWidget *button, gpointer data ) 
{
  GtkWidget *popup_window; 
  gint x_pos,y_pos;
  
  right_button_event = TRUE;
  

  gtk_widget_set_sensitive(get_toolbar_widget(9),FALSE);
  popup_window=create_popup_window (win_main);
  gtk_window_set_transient_for( GTK_WINDOW(popup_window),
				GTK_WINDOW (win_main));
  gdk_window_get_origin(drawingarea2->parent->window,&x_pos,&y_pos);
  gtk_widget_set_uposition(popup_window, x_pos,y_pos);
  gtk_widget_show (popup_window);
}


/******************************************************************************
 * Name:        on_right_button_activate
 *-----------------------------------------------------------------------------
 * Description: This function gets called when right mouse button becomes
 *              active. it is called from with in the button_press_event 
 *              function. It enables or disables various items in the popup 
 *              menu.
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - normally the drawable area
 *    event - a button event  
 ******************************************************************************/
void
on_right_button_activate(GtkWidget*widget,GdkEventButton *event)
  
{
 
  GtkWidget *Fill_Bounded;
  GtkWidget *Fill_Replace;
  GtkWidget *Rotate_Map;
  GtkWidget *Pick_Color;
  GtkWidget *Map_Settings;

 
  right_button_event = TRUE;
 
  if (popup_menu==NULL)
    popup_menu=create_popup_menu (win_main);

  if(button_press (popup_menu,(GdkEvent *)event)){
     Pick_Color = (GtkWidget*) gtk_object_get_data (GTK_OBJECT ( popup_menu),
                                                   "Pick_Color_from_Map");
     Fill_Bounded = (GtkWidget*) gtk_object_get_data (GTK_OBJECT ( popup_menu),
                                                   "Fill_Bounded");
     Fill_Replace = (GtkWidget*) gtk_object_get_data (GTK_OBJECT ( popup_menu),
                                                   "Fill_Replace");
     Rotate_Map = (GtkWidget*) gtk_object_get_data (GTK_OBJECT ( popup_menu),
                                                   "Rotate_Map");
     Map_Settings = (GtkWidget*) gtk_object_get_data (GTK_OBJECT ( popup_menu),
                                                   "Map_Settings");
    if (Map->col_list_ptr != NULL){
      gtk_widget_set_sensitive(Fill_Bounded,TRUE);
      gtk_widget_set_sensitive(Fill_Replace,TRUE);
      gtk_widget_set_sensitive(Rotate_Map,TRUE);
      gtk_widget_set_sensitive(Pick_Color,TRUE);
      gtk_widget_set_sensitive(Map_Settings,EnableSetupFlag);}
    else{
      gtk_widget_set_sensitive(Fill_Bounded,FALSE);
      gtk_widget_set_sensitive(Fill_Replace,FALSE);
      gtk_widget_set_sensitive(Rotate_Map,FALSE);
      gtk_widget_set_sensitive(Pick_Color,FALSE);
      gtk_widget_set_sensitive(Map_Settings,FALSE);}
  }

}

/******************************************************************************
 * Name:        FindLocation
 *-----------------------------------------------------------------------------
 * Description: This function finds and displays the global position and 
 *              elevation of a selected point on the map. It displays the results
 8              it in a dialog box.
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    xpoint -  X postion on the map
 *    ypoint -  Y postion on the map
 *    data  - not used at this time. 
 ******************************************************************************/
void FindLocation(gint xpoint,gint ypoint, gpointer data) {

  GtkWidget* dialog;
  gchar buffer[80];
  float  NWXPOS;
  float  NWYPOS;

 if (Map->NWXPOS >  Map->SWXPOS)
   NWXPOS = Map->SWXPOS;
 else
   NWXPOS = Map->NWXPOS;

 if (Map->NWYPOS < Map->NEYPOS)
   NWYPOS = Map->NEYPOS;
 else
   NWYPOS = Map->NWYPOS;
 

  if (Map->GUnit==3 && Map->ElvUint != 1)
  sprintf(buffer,"Lng: %.2f arc sec\"\nLat: %.2f arc sec\"\nElevation: %.2f meter",
	  NWXPOS+(Map->spatial_resolution_x*xpoint),
	  NWYPOS-(Map->spatial_resolution_y*ypoint),
	  (map_get_elv(Map->col_list_ptr,xpoint,ypoint)*
	  Map->spatial_resolution_z+Map->minelev));
   if (Map->GUnit==2 && Map->ElvUint != 1)
  sprintf(buffer,"Easting: %.2f UTM\nNorthing: %.2f UTM\nElevation: %.2f meter",
	  NWXPOS+(Map->spatial_resolution_x*xpoint),
	  NWYPOS-(Map->spatial_resolution_y*ypoint),
	  map_get_elv(Map->col_list_ptr,xpoint,ypoint)*
	  Map->spatial_resolution_z+Map->minelev);
if (Map->GUnit==3 && Map->ElvUint == 1)
  sprintf(buffer,"Lng: %.2f arc sec\"\nLat: %.2f arc sec\"\nElevation: %.2f feet",
	  NWXPOS+(Map->spatial_resolution_x*xpoint),
	  NWYPOS-(Map->spatial_resolution_y*ypoint),
	  (map_get_elv(Map->col_list_ptr,xpoint,ypoint)*
	  Map->spatial_resolution_z+Map->minelev));
   if (Map->GUnit==2 && Map->ElvUint == 1)
  sprintf(buffer,"Easting: %.2f UTM\nNorthing: %.2f UTM\nElevation: %.2f feet",
	  NWXPOS+(Map->spatial_resolution_x*xpoint),
	  NWYPOS-(Map->spatial_resolution_y*ypoint),
	  map_get_elv(Map->col_list_ptr,xpoint,ypoint)*
	  Map->spatial_resolution_z+Map->minelev);

  dialog = gnome_ok_dialog_parented(buffer, GTK_WINDOW(win_main));

}


/******************************************************************************
 * Name:        draw_brush 
 *-----------------------------------------------------------------------------
 * Description: This function draws a object on the screen that was  
 *              previously defined by draw_area_event.( Draws on the screen )
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - normally the drawable area
 *    x - x mouse position
 *    y - y mouse position
 *    drawtype - the type of object to draw on the screen
 *    gc  - a gdk graphical contect
 *    data - normally a pointer to the main window
 ******************************************************************************/
void
draw_brush       (GtkWidget *widget, gdouble x, gdouble y, 
		  int drawtype, GdkGC *gc, gpointer data )
{
  GtkWidget *colorarea;
  GtkWidget *check_line;
  GdkRectangle update_rect;
  static gdouble last_x = 0;
  static gdouble last_y = 0;
  static gdouble next_x = 0;
  static gdouble next_y = 0;
  static gdouble oldx = 0;
  static gdouble oldy = 0;
  static gdouble rec_width = 0;
  static gdouble rec_height = 0;
  static gint Max_x,Max_y,Min_x,Min_y;
  static char BUFF[20];
  double zp,xp,yp,zz,xx,yy;
  static double oldAx=0,oldAy=0;
  update_rect.x = x - 5;
  update_rect.y = y - 5;
  update_rect.width  = 10;
  update_rect.height  = 10;

  check_line  = get_widget ((GtkWidget *) win_main, "glade_menuitem4");
  colorarea =get_widget ((GtkWidget *) win_main, "colorarea");
 
  if(drawtype_motion_event ==15)
    sprintf(BUFF,"x:%d   y:%d",(int)x,(int)y);
  if(drawtype_motion_event ==14)
    sprintf(BUFF,"x axis angle:%d   y axis angle:%d",(int)Ax,(int)Ay);
  else
    sprintf(BUFF,"X position:%d   Y position:%d",(int)Wlast_x,(int)Wlast_y);

  push_item(NULL,BUFF);

  if (gc != NULL){
  switch (drawtype)
  {
   case 0:
        if (Map->col_list_ptr != NULL && (drawtype_motion_event ==15 ||
	    drawtype_motion_event ==14))
	{ 
	  if (GTK_CHECK_MENU_ITEM( check_line)->active)
	    Generate_Wire_frame(Map,bkpixmap,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step,Ax,Ay,Az,
				0,MapColor,(float)imsize*4);
	  else
	    Generate_Wire_frame(Map,bkpixmap,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step,Ax,Ay,Az,
				1,MapColor,(float)imsize*4);
	  oldx=Wlast_x;
	  oldy=Wlast_y;
	  oldAx=Ax;
	  oldAy=Ay;
	  /* set update rectangle size */
	  update_rect.x =0;
	  update_rect.y =0;
	  update_rect.width  = Map->pixmap_size.x;		      
	  update_rect.height = Map->pixmap_size.y;
	}
       /* set start point */
       last_x = x; Min_x = x;
       next_x = x; Max_x = x;
       next_y = y; Max_y = y;
       last_y = y; Min_y = y;
       break;

   case 1:
       /*draw Rec */ 
       if (last_x <= next_x) rec_width = next_x-last_x; else rec_width = 0;
       if (last_y <= next_y) rec_height = next_y-last_y; else rec_height = 0;
       gdk_draw_rectangle (bkpixmap,
		        newgc,
			FALSE,
		        last_x,	last_y,
			rec_width, rec_height);
       if (Map->col_list_ptr != NULL)
       gtk_map_draw_rectangle (Map,
		        newgc,
			FALSE,
		        last_x,	last_y,
			rec_width, rec_height);
                        /* set update rectangle size */
			if (next_x > Max_x) Max_x=next_x+1;
			if (next_x < Min_x) Min_x=next_x-1;
			if (next_y > Max_y) Max_y=next_y+1;
			if (next_y < Min_y) Min_y=next_y-1;
			update_rect.x = Min_x;
			update_rect.y = Min_y;
			update_rect.width  = Max_x;
			update_rect.height  = Max_y;	
                        break;

   case 2:
       /* errase last Rec*/
       if (last_x <= next_x) rec_width = next_x-last_x; else rec_width = 0;
       if (last_y <= next_y) rec_height = next_y-last_y; else rec_height = 0;
       gdk_draw_rectangle (bkpixmap,
			invertgc,
			FALSE,
 			last_x,	last_y,
			rec_width, rec_height);
       /* draw new Rec */ 
       if (last_x <= x) rec_width = x-last_x; else rec_width = 0;
       if (last_y <= y) rec_height = y-last_y; else rec_height = 0;
       gdk_draw_rectangle (bkpixmap,
			invertgc,
			FALSE,
 			last_x,	last_y,	rec_width, rec_height);
                        /* set update rectangle size */	
                        next_x = x; next_y = y;
                        /* set update rectangle size */
			if (next_x > Max_x) Max_x=next_x+1;
			if (next_x < Min_x) Min_x=next_x-1;
			if (next_y > Max_y) Max_y=next_y+1;
			if (next_y < Min_y) Min_y=next_y-1;
			update_rect.x = Min_x;
			update_rect.y = Min_y;
			update_rect.width  = Max_x;
			update_rect.height  = Max_y;	
                        break;
    
   case 3:
     /*draw line */ 
     gdk_draw_line    (bkpixmap,
		        newgc,
		        last_x, last_y,next_x,next_y);
     if (Map->col_list_ptr != NULL)
     gtk_map_draw_line    (Map,newgc,
		       last_x, last_y,  next_x, next_y);
                       /* set update rectangle size */
                       if (next_x > Max_x) Max_x=next_x;
		       if (next_x < Min_x) Min_x=next_x;
		       if (next_y > Max_y) Max_y=next_y;
		       if (next_y < Min_y) Min_y=next_y;
		       update_rect.x = Min_x;
		       update_rect.y = Min_y;
		       update_rect.width  = Max_x;
		       update_rect.height  = Max_y;			  
		       break;	
   case 4:
     /* errase last line*/
     gdk_draw_line    (bkpixmap,
		       invertgc,
		       last_x, last_y, next_x, next_y);
     /* draw new line */                  
     gdk_draw_line     (bkpixmap,
		       invertgc,
		       last_x, last_y, x, y);
                       /* set update rectangle size */	
                       next_x = x; next_y = y;
		       /* set update rectangle size */
		       if (next_x > Max_x) Max_x=next_x;
		       if (next_x < Min_x) Min_x=next_x;
		       if (next_y > Max_y) Max_y=next_y;
		       if (next_y < Min_y) Min_y=next_y;
		       update_rect.x = Min_x;
		       update_rect.y = Min_y;
		       update_rect.width  = Max_x;
		       update_rect.height  = Max_y;	
		       break;
  case 5:
    /* draw line */              
     gdk_draw_line     (bkpixmap,
		        newgc,
			last_x, last_y, x, y);
                       /* set update rectangle size */	
                       next_x = x; next_y = y;
		       /* set update rectangle size */
		       if (next_x > Max_x) Max_x=next_x;
		       if (next_x < Min_x) Min_x=next_x;
		       if (next_y > Max_y) Max_y=next_y;
		       if (next_y < Min_y) Min_y=next_y;
		       update_rect.x = Min_x;
		       update_rect.y = Min_y;
		       update_rect.width  = Max_x;
		       update_rect.height  = Max_y;
		    	
     if (Map->col_list_ptr != NULL)
     gtk_map_draw_line   (Map,
			  newgc,
			  last_x, last_y,x, y);
                          last_x=x; last_y=y;
                          break;

  case 6:
    if (Map->col_list_ptr != NULL){
   last_x=x;last_y=y;
   Ay=last_y-y; Ax=last_x-x;
   xx=40; yy=0; zz=0;
	   //rotation along y axis
	   xp =xx *cos(Ax*.01745) + zz * sin(Ax*.01745);
	   zp = -xx * sin(Ax*.01745)+ zz * cos(Ax*.01745);
	   zz=zp; xx=xp;
	   //rotation along x axis
	   yp=yy*cos(Ay*.01745)- zz * sin(Ay*.01745);
	   zp=xx*sin(Ay*.01745)+ zz * cos(Ay*.01745);
	   zz=zp; yy=yp;
	   xp=xx+last_x; yp=yy+last_y;	  
	   gdk_draw_line    (bkpixmap,
			     gc,
			last_x, last_y,  xp, yp); 
           xx=0; yy=40; zz=0;
	   //rotation along y axis
	   xp =xx *cos(Ax*.01745) + zz * sin(Ax*.01745);
	   zp = -xx * sin(Ax*.01745)+ zz * cos(Ax*.01745);
	   zz=zp; xx=xp;
	   //rotation along x axis
	   yp=yy*cos(Ay*.01745)- zz * sin(Ay*.01745);
	   zp=xx*sin(Ay*.01745)+ zz * cos(Ay*.01745);
	   zz=zp; yy=yp;
	   xp=xx+last_x; yp=yy+last_y;	  
     gdk_draw_line    (bkpixmap,
			gc,
			last_x, last_y,  xp, yp); 
           xx=0; yy=0; zz=40;
	 //rotation along y axis
	   xp =xx *cos(Ax*.01745) + zz * sin(Ax*.01745);
	   zp = -xx * sin(Ax*.01745)+ zz * cos(Ax*.01745);
	   zz=zp; xx=xp;
	  //rotation along x axis
	   yp=yy*cos(Ay*.01745)- zz * sin(Ay*.01745);
	   zp=xx*sin(Ay*.01745)+ zz * cos(Ay*.01745);
	   zz=zp; yy=yp;
	   xp=xx+last_x; yp=yy+last_y;	  
	   gdk_draw_line    (bkpixmap,
			gc,
			last_x, last_y,  xp, yp); 
	   next_x=x; next_y=y;
	   /* set update rectangle size */
	   update_rect.x = last_x-41;
	   update_rect.y = last_y-41;
	   update_rect.width  = last_x+41;		      
	   update_rect.height = last_y+41;}			  
                       
                        break;	
  case 7:
    if (Map->col_list_ptr != NULL){ 
          Ay=last_y-next_y; Ax=last_x-next_x;
	  xx=40; yy=0; zz=0;
           //rotate along z axis
	   xp=xx*cos(Ax*.01745)-yy*sin(Ax*.01745);
	   yp=xx*sin(Ax*.01745)+yy*cos(Ax*.01745);
	   yy=yp; xx=xp;

	   //rotation along x axis
	   yp=yy*cos(Ay*.01745)- zz * sin(Ay*.01745);
	   zp=xx*sin(Ay*.01745)+ zz * cos(Ay*.01745);
	   zz=zp; yy=yp;
	   xp=xx+last_x; yp=yy+last_y;      
     gdk_draw_line    (bkpixmap,
			gc,
			last_x, last_y,  xp, yp);
           xx=0; yy=40; zz=0;
	 //rotate along z axis
	   xp=xx*cos(Ax*.01745)-yy*sin(Ax*.01745);
	   yp=xx*sin(Ax*.01745)+yy*cos(Ax*.01745);
	   yy=yp; xx=xp;
	
	  //rotation along x axis
	   yp=yy*cos(Ay*.01745)- zz * sin(Ay*.01745);
	   zp=xx*sin(Ay*.01745)+ zz * cos(Ay*.01745);
	   zz=zp; yy=yp;
	   xp=xx+last_x; yp=yy+last_y;	  
     gdk_draw_line    (bkpixmap,
			gc,
			last_x, last_y,  xp, yp); 
           xx=0; yy=0; zz=40;
	  //rotate along z axis
	   xp=xx*cos(Ax*.01745)-yy*sin(Ax*.01745);
	   yp=xx*sin(Ax*.01745)+yy*cos(Ax*.01745);
	   yy=yp; xx=xp;	
	  //rotation along x axis
	   yp=yy*cos(Ay*.01745)- zz * sin(Ay*.01745);
	   zp=xx*sin(Ay*.01745)+ zz * cos(Ay*.01745);
	   zz=zp; yy=yp;
	   xp=xx+last_x; yp=yy+last_y;	  
     gdk_draw_line    (bkpixmap,
			gc,
			last_x, last_y,  xp, yp); 

           Ay=last_y-y; Ax=last_x-x;
           xx=40; yy=0; zz=0;
          //rotate along z axis
	   xp=xx*cos(Ax*.01745)-yy*sin(Ax*.01745);
	   yp=xx*sin(Ax*.01745)+yy*cos(Ax*.01745);
	   yy=yp; xx=xp;
	  //rotation along x axis
	   yp=yy*cos(Ay*.01745)- zz * sin(Ay*.01745);
	   zp=xx*sin(Ay*.01745)+ zz * cos(Ay*.01745);
	   zz=zp; yy=yp;
	   xp=xx+last_x; yp=yy+last_y;	  
     gdk_draw_line    (bkpixmap,
			gc,
			last_x, last_y,  xp, yp); 
           xx=0; yy=40; zz=0;
         //rotate along z axis
	   xp=xx*cos(Ax*.01745)-yy*sin(Ax*.01745);
	   yp=xx*sin(Ax*.01745)+yy*cos(Ax*.01745);
	   yy=yp; xx=xp;
	  //rotation along x axis
	   yp=yy*cos(Ay*.01745)- zz * sin(Ay*.01745);
	   zp=xx*sin(Ay*.01745)+ zz * cos(Ay*.01745);
	   zz=zp; yy=yp;
	   xp=xx+last_x; yp=yy+last_y;	  
     gdk_draw_line    (bkpixmap,
			gc,
			last_x, last_y,  xp, yp); 
           xx=0; yy=0; zz=40;
          //rotate along z axis
	   xp=xx*cos(Ax*.01745)-yy*sin(Ax*.01745);
	   yp=xx*sin(Ax*.01745)+yy*cos(Ax*.01745);
	   yy=yp; xx=xp;
	  //rotation along x axis
	   yp=yy*cos(Ay*.01745)- zz * sin(Ay*.01745);
	   zp=xx*sin(Ay*.01745)+ zz * cos(Ay*.01745);
	   zz=zp; yy=yp;
	   xp=xx+last_x; yp=yy+last_y;	  
     gdk_draw_line    (bkpixmap,
			gc,
			last_x, last_y,  xp, yp); 
     next_x=x; next_y=y;
                       /* set update rectangle size */
                          update_rect.x = last_x-41;
			  update_rect.y = last_y-41;
			  update_rect.width  = last_x+41;		      
			  update_rect.height = last_y+41;}	       	       
                        break;	
  case 8:
    if (Map->col_list_ptr != NULL)       
      Generate_DEM(data,1,Ax,Ay,0,0);
                        break;
  case 9:
    if (Map->col_list_ptr != NULL){
      gtk_map_fill_bounded   (Map,
			      newgc,
			      x, y);
      Generate_DEM(data,0,0,0,0,TRUE);}
    break;
  case 10:
    if (Map->col_list_ptr != NULL){
    gtk_map_fill_replace   (Map,
			newgc,
			x, y);
    Generate_DEM(data,0,0,0,0,TRUE);}
                        break;
  case 11:
    if (Map->col_list_ptr != NULL){
    gtk_copy_gc_Map(Map->col_list_ptr,newgc,x,y);
    gdk_draw_rectangle (colorarea->window,
		        newgc,
			TRUE,
		        0,0,
			colorarea->allocation.width,
			colorarea->allocation.height);}
		        break;
  case 12:
    /* draw point */
    gdk_draw_point   (bkpixmap,
		      newgc, x, y);
                      /* set update rectangle size */
		      update_rect.x = x-1;
		      update_rect.y = y-1;
		      update_rect.width  = x+1;
		      update_rect.height  = y+1;
     /* draw new line */
    if (Map->col_list_ptr != NULL)                  
      gtk_map_draw_point (Map,
			  newgc,
			  x, y);
                      last_x = x; Min_x = x;
		      next_x = x; Max_x = x;
		      next_y = y; Max_y = y;
		      last_y = y; Min_y = y;
                       break;
  case 13:
    FindLocation(x,y,data);
    break;

  case 14:
        
        if (Map->col_list_ptr != NULL)
	{
	  Ax=oldAx-(int)(x-last_x);
	  Ay=oldAy-(int)(y-last_y);
	  if(Ax<0) Ax=Ax+360;
	  if(Ax>360) Ax=Ax-360;
	  if(Ay<0) Ay=0;
	  if(Ay>90) Ay=90;
	  if (GTK_CHECK_MENU_ITEM( check_line)->active)
	    Generate_Wire_frame(Map,bkpixmap,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step, Ax,Ay,Az,
				0,MapColor,(float)imsize*4);
	  else
	    Generate_Wire_frame(Map,bkpixmap,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step, Ax,Ay,Az,
				1,MapColor,(float)imsize*4);
	  /* set update rectangle size */
	  update_rect.x =0;
	  update_rect.y =0;
	  update_rect.width  = Map->pixmap_size.x;		      
	  update_rect.height = Map->pixmap_size.y;
	}   

    break;

  case 15:
 
        if (Map->col_list_ptr != NULL)
	{ 
	  Wlast_x=oldx-(x-last_x);
	  Wlast_y=oldy-(y-last_y);
          if(Wlast_y<0) Wlast_y=0;
	  if(Wlast_x<0) Wlast_x=0;
          if(Wlast_y>Map->col_list_ptr[0].lsize) Wlast_y=Map->col_list_ptr[0].lsize;
	  if(Wlast_x>Map->col_list_ptr[0].ptr[0].z) Wlast_x=Map->col_list_ptr[0].ptr[0].z;
	  if (GTK_CHECK_MENU_ITEM( check_line)->active)
	    Generate_Wire_frame(Map,bkpixmap,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step,Ax,Ay,Az,
				0,MapColor,(float)imsize*4);
	  else
	    Generate_Wire_frame(Map,bkpixmap,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step,Ax,Ay,Az,
				1,MapColor,(float)imsize*4);
	  /* set update rectangle size */
	  update_rect.x =0;
	  update_rect.y =0;
	  update_rect.width  = Map->pixmap_size.x;		      
	  update_rect.height = Map->pixmap_size.y;
	}   

    break;

  case 16:
        //remember the old positions
        if (drawtype_motion_event ==15)
        {
	  oldx=Wlast_x;
	  oldy=Wlast_y;
        }
	if (drawtype_motion_event ==14)
        {
	  oldAx=Ax;
	  oldAy=Ay;
        }

	gdk_draw_pixmap (Map->pixmap,
			drawingarea2->style->white_gc,
			bkpixmap,
			0,0,
			0,0,
			Map->pixmap_size.x,
		 	Map->pixmap_size.y);
    break;

  default:
    break;
  }

gtk_widget_draw (widget, &update_rect);
}
}





/******************************************************************************
 * Name:        button_press_event
 *-----------------------------------------------------------------------------
 * Description: This function gets called when a mouse button is pressed. The 
 *              mouse event sequence was set up by a pervious call to 
 *              draw_area_event. The draw area events are defined in the 
 *              draw_brush function. This
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - a drawable area
 *    event - normally a mouse event 
 *    data - pointer 
 ******************************************************************************/
static gint
button_press_event                     (GtkWidget    *widget,
                                        GdkEventButton     *event,
					gpointer data)
{
  if (event->button == 1 && bkpixmap !=NULL)
    {
      draw_brush (widget, event->x, event->y, drawtype_press_event, 
		  invertgc, NULL);
      mouse_button_pressed = TRUE;
      right_button_event=FALSE;
    }
  else if (event->button == 3)
    on_right_button_activate(widget,event);
  
  return TRUE;
}

/******************************************************************************
 * Name:        button_release_event
 *-----------------------------------------------------------------------------
 * Description: This function gets called when a mouse button is released.
 *              mouse event sequence was set up by a pervious call to 
 *              draw_area_event. The draw area events are defined in the 
 *              draw_brush function. This
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - a drawable area
 *    event - normally a mouse event 
 *    data - pointer   
 ******************************************************************************/
static gint
button_release_event                     (GtkWidget    *widget,
					  GdkEventButton     *event,
					  gpointer data)
{
  
  if (event->button == 1 && bkpixmap !=NULL && !right_button_event)
    {
    draw_brush (widget, event->x, event->y, drawtype_release_event, 
		newgc, data);
    //mpx = event->x;
    //mpy = event->y;
    mouse_button_pressed =FALSE;
    }
  else
    right_button_event = FALSE;
  
  return TRUE;
}


/******************************************************************************
 * Name:        motion_notify_event
 *-----------------------------------------------------------------------------
 * Description: This function gets called when a mouse button is moved in the
 *              darw area. The mouse event sequence was set up by a pervious 
 *              call to draw_area_event. The draw area events are defined in the 
 *              draw_brush function. This
 *
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - a drawable area
 *    event - normally a mouse event 
 *    data - pointer   
 ******************************************************************************/
static gint
motion_notify_event (GtkWidget *widget, GdkEventMotion *event, gpointer data)
{
  int x, y;
  GdkModifierType state;
 

  if (event->is_hint)
    gdk_window_get_pointer (event->window, &x, &y, &state);
  else
    {
      x = event->x;
      y = event->y;
      state = event->state;
      
    }
  if (state & GDK_BUTTON1_MASK && bkpixmap != NULL &&  
      mouse_button_pressed && !right_button_event)
    draw_brush (widget, x, y,drawtype_motion_event , invertgc, data);
 
  
   
  return TRUE;
}

/* ---------------color selection------------------- */
void
color_changed_cb                       (GtkMenuItem     *menuitem,
                                        GtkColorSelection *colorsel)
{
 GtkWidget *colorarea;
 gdouble color[3];
 GdkColor gdk_color;
 char BUFF[20];

 colorarea =get_widget ((GtkWidget *) win_main, "colorarea");

 gtk_color_selection_get_color(colorsel,color);

 gdk_color.red = (guint16) (color[0]*65535.0);
 gdk_color.green = (guint16) (color[1]*65535.0);
 gdk_color.blue = (guint16) (color[2]*65535.0);
 gdk_color_alloc (gdk_colormap_get_system(), &gdk_color);

 gdk_gc_set_foreground (newgc, &gdk_color);
 gdk_gc_set_fill (newgc, GDK_SOLID);
 
 sprintf(BUFF, "R:%d G:%d B:%d",gdk_color.red, gdk_color.green,gdk_color.blue);
 push_item(NULL,BUFF);
 gdk_draw_rectangle (colorarea->window,
		     newgc,
		     TRUE,
		     0,0,
		     colorarea->allocation.width,
		     colorarea->allocation.height);
 if (Map->col_list_ptr != NULL)
   GetPenNumber(newgc);
}

void
on_colorBox_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 GtkWidget *colorselectiondialog1;
 GtkWidget *colorsel;

 colorselectiondialog1 = create_colorselectiondialog1 ();
 gtk_widget_show (colorselectiondialog1);
 colorsel = GTK_COLOR_SELECTION_DIALOG( colorselectiondialog1)->colorsel;

 gtk_signal_connect (GTK_OBJECT ( menuitem), "clicked",
                      GTK_SIGNAL_FUNC (push_item),
                       "Select Color");
 gtk_signal_connect_object (GTK_OBJECT ( GTK_COLOR_SELECTION_DIALOG (colorselectiondialog1)->cancel_button ),
			    "clicked", (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (colorselectiondialog1));

 gtk_signal_connect_object (GTK_OBJECT (colorsel),
			    "color_changed", (GtkSignalFunc) color_changed_cb,
			     (gpointer)colorsel);

 gtk_signal_connect_object (GTK_OBJECT ( GTK_COLOR_SELECTION_DIALOG (colorselectiondialog1)->ok_button ),
			    "clicked", (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (colorselectiondialog1));

return;
}

/* ---------------load DEM file------------------- */
double FindnextFloatn (FILE * fptr, int n) {
  char ch;
  int i=0,j=1;
  char in[64];
  
  while(isspace(ch = fgetc(fptr)) && j>=n) {j++;}
  i=0;  
  in[0] = ch;
  while(j < n) {
    ch = fgetc(fptr); 
    i++;
    j++; 
    if(ch == 'D') { ch = 'E'; }
    in[i] = ch; 
  }
  in[i+1] = '\0';
;
  return  atof(in);
}

int FindnextInteger(FILE * fptr) {
  char ch;
  int i;
  char in[64];
  
  while(isspace(ch = fgetc(fptr))) { }
  i=0;
  in[0] = ch;  
  while(!isspace(ch = fgetc(fptr)) && i < 20) { i++; in[i] = ch; }
  in[i+1] = '\0';
  if (i >=20 )
    return -1;
  else
    return(atoi(in));
} 
          
double FindnextFloat (FILE * fptr) {
  char ch;
  int i;
  char in[64];
  
  while(isspace(ch = fgetc(fptr))) { }
  i=0;
  in[0] = ch;
  while(!isspace(ch = fgetc(fptr))) { 
    i++; 
    if(ch == 'D') { ch = 'E'; }
    in[i] = ch; 
  }
  in[i+1] = '\0';
  return  atof(in);
}

char* FindnextString(FILE * fptr) {
  char ch;
  int i;
  static char in[64];
  
  while(isspace(ch = fgetc(fptr))) { }
  i=0;
  in[0] = ch;
  while(!isspace(ch = fgetc(fptr))) { 
    i++; 
    in[i] = ch; 
  }
  in[i+1] = '\0';
  return in;
}

char FindnextChar(FILE * fptr) {
  char ch;
  int i;
  static char in[64];
  
  while(isspace(ch = fgetc(fptr))) { }
  i=0;
  in[0] = ch;
  return  in[0];
}

/* DEM file GtkFileSelection*/
void set_filein(GtkWidget *w, GtkWidget *fs){
 
  filein = gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));
  gtk_widget_hide (fs);
  gtk_grab_remove(fs);
   while (gtk_events_pending())
      gtk_main_iteration();
  File2_stat = TRUE;
}

 static float  xNWc,xNEc,xSWc,xSEc,yNWc,yNEc,ySWc,ySEc,
               xASSEc,xASNWc,yASNWc,yASSEc; 

void DLGUTMtoGEO(float UTMNorthing, float UTMEasting,
		double *lat, double *lng , int flag) 
{
  static float Maxdx, Maxoy, ddy1, Maxdy, Maxox, ddx1,ddx2, 
               Maxdy2, Maxox2, xdAS,ydAS, ddxAS,ddyAS;             
  float dx=0,dy=0,A=0,B=0,C=0;

  if(flag == -1){
  Maxdx = xNEc-xNWc;
  Maxoy = yNEc-yNWc;
  ddy1 = Maxoy/Maxdx;
  Maxdy = yNWc-ySWc;
  Maxox = xSWc-xNWc;
  ddx1 = Maxox/Maxdy;
  Maxdy2 = yNEc-ySEc;
  Maxox2 = xSEc-xNEc;
  ddx2 = Maxox2/Maxdy2;
  xdAS = xASSEc-xASNWc; ddxAS=xdAS/(xNEc-xNWc);
  ydAS = yASNWc-yASSEc; ddyAS=ydAS/(yNWc-ySWc);}
 

  if (lat != NULL || lng != NULL){
    dx = UTMEasting-xNWc;
    dy = yNWc-UTMNorthing;
    A=ddx1*dy; B=ddy1*dx; C=(ddx2*dy)-A;
    *lng=(((UTMEasting-A-C)-xNWc)*ddxAS)+xASNWc;
    *lat=yASNWc-((yNWc-(UTMNorthing-B))*ddyAS);}
}

char *formatlogstring(char *str){
  gint i=0;
  static char buffer[50];
  
  for(i=0; i<49; i++){
    if ( (isprint(str[i]) || str[i]=='') && i<strlen(str))
      buffer[i]=str[i];
    else
      buffer[i]=' ';}
  buffer[49]='\n';
return buffer;
}



void save_log(gpointer data ) {

 GtkWidget *clist;
 FILE *outfile;
 gint i=0;
 gchar *buffer;

 clist = get_widget ((GtkWidget *) data, "clist3"); 
  push_item( NULL,"Saving Log  . . .");
   while (gtk_events_pending())
      gtk_main_iteration();

 if (	File2_stat == FALSE)
   return;
 g_print("saving log");
 outfile = fopen(filein, "w");

 while(gtk_clist_get_text(GTK_CLIST(clist),i,0,&buffer) != 0){
  
     gtk_clist_get_text(GTK_CLIST(clist),i,0,&buffer);
     fwrite(formatlogstring(buffer), sizeof(char), 50 ,outfile);
     gtk_clist_get_text(GTK_CLIST(clist),i,1,&buffer);
     fwrite(formatlogstring(buffer), sizeof(char), 50 ,outfile);
     gtk_clist_get_text(GTK_CLIST(clist),i,2,&buffer);
     fwrite(formatlogstring(buffer), sizeof(char), 50 ,outfile);
     gtk_clist_get_text(GTK_CLIST(clist),i,3,&buffer);
     fwrite(formatlogstring(buffer), sizeof(char), 50 ,outfile);
    
     i++;}

 fclose(outfile);

  }

gboolean getlog(FILE * fptr, char *in) {
  char ch;
  gboolean flag =TRUE;
  int i=0;
 
  while(((ch = fgetc(fptr))!='\n' || (ch = fgetc(fptr))!= EOF)&& i<48) { 
    in[i] = ch;
    i++;  
  }
  in[i]='\0';
  if(ch ==EOF) flag=FALSE;
  return flag;
}

void open_log(gpointer data ) {

 GtkWidget *clist;
 FILE *infile;
 gboolean flag =TRUE;
 gchar  str[50];
 gchar *format[4];
 gchar  str1[80],str2[80],str3[80],str4[80];
 
 format[0]=str1;
 format[1]=str2;
 format[2]=str3;
 format[3]=str4;
 clist = get_widget ((GtkWidget *) data, "clist3"); 
 
 push_item( NULL,"Loading Log  . . .");
 while (gtk_events_pending())
      gtk_main_iteration();

 if (	File2_stat == FALSE)
   return;
 gtk_clist_freeze(GTK_CLIST(clist));
 infile = fopen(filein, "r");
 while (flag==TRUE){
   flag=getlog(infile,str);
   sprintf(format[0],"%s",str);
   flag=getlog(infile,str);
   sprintf(format[1],"%s",str);
   flag=getlog(infile,str);
   sprintf(format[2],"%s",str);
   flag=getlog(infile,str);
   sprintf(format[3],"%s",str);
   if ( format[0] != "\n" && flag==TRUE ) 
     gtk_clist_append((GtkCList*) clist, format);
 }
  fclose(infile);
  DrawWP(data);
   push_item( NULL,"Done . . .");
   gtk_clist_thaw(GTK_CLIST(clist));
}


int DEMtoIMAGE(gpointer data ) {
  GtkWidget* dialog;
  GtkWidget *drawingarea2;
  GtkWidget *dialog_bar;
  GtkWidget *Mapper;
  char buffer[250],buffer1[32],buffer2[32];
  int nchars;
  int char_count =0;
  FILE *demfile;
  gint i=0,j=0,h=0, l=0, ElvUint;
  float  k= 0,elev=0;
  int maxelev=0, minelev=0;
  int bottomrow;
  int elevrange=0;
  GtkWidget *demmap;
  GtkWidget *progressbar3;
  gchar *demlist[4];
  gchar  demid[20];
  char filename[145];
  int rows=0, columns=0,row1=0;
  int cur_r=0, cur_c=0;
  int in1,in2,in3,in4;
  float colormap_scale,stepsize,fmaxelev;  
  
  int temp =0;
 
  float  PosRow, PosCol, XPOS, YPOS;
  

 
 Mapper  = get_widget ((GtkWidget *) data, "Mapper");
 drawingarea2  = get_widget ((GtkWidget *) data, "drawingarea2");

 demmap  = get_widget ((GtkWidget *) data, "clist3");
 dialog_bar  = get_widget ((GtkWidget *) data, "dialog_bar");
 progressbar3 = get_widget (dialog_bar, "progressbar3");

 initialize_map (data);
 push_item( NULL,"loading DEM Map . . .");
 gtk_text_backward_delete(GTK_TEXT (text2),
			  gtk_text_get_length(GTK_TEXT (text2)));

  gtk_text_freeze (GTK_TEXT (text2));

  if (	File2_stat == FALSE)
    return(-1);
 
 
  if ((demfile = fopen(filein, "r")) == NULL ){
    g_print ("Can,t open %s for reading.\n", filein);
    fclose(demfile);
    return(-1);

  } 

 /* DEM TYPE A RECORDS */
  //Quadrangle name field 
  for(i=0; i < 149; i++) 
    {filename[i] = getc(demfile); }
  //filename[i+1] = '\0';
 filename[38] = '\0';
  /* clean off the whitespace at the end */
  for(i=strlen(filename)-2; i > 0; i--) {
    if(!isspace(filename[i])) { i=0; } else { filename[i] = '\0'; }
     }
  nchars = sprintf (buffer,"DEM Map: %s.\n", filename);
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);

  in1=FindnextInteger(demfile);//DEM Level code
  in2=FindnextInteger(demfile);//Patten code
  in3=FindnextInteger(demfile);//Palaimetric reference system code
  in4=FindnextInteger(demfile);//Zone code


  /* don't need the next 19 items for anything (Map projection parameters) */
  for(i=0; i < 15; i++) { (void)FindnextInteger(demfile); }
  Map->GUnit=FindnextInteger(demfile);//Unit code (unit of mesure for ground planimetric)
 
  ElvUint=FindnextInteger(demfile);//Unit code (unit of mesure for elevation)
  Map->ElvUint = ElvUint;
  (void)FindnextInteger(demfile);//Number (n) of sides in the polygon
 
  nchars = sprintf(buffer,"\nGround coordinates of 4 corners of DEM: \n");
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);
  //strcpy( buffer,"\n"); 
  sprintf (buffer,"DEM File: %s\n",filein);
  strcpy( demid, buffer); 
  demlist[0]= buffer;
  demlist[2]= " ";
  demlist[1]= " ";
  demlist[3]= " ";
  //row=gtk_clist_append((GtkCList*) demmap, demlist);
  //gtk_clist_set_row_data((GtkCList*) demmap,row,NULL);
  /* A 4,2 array containing the ground coordinates */
  for(i=1; i<=4; i++){
    XPOS=FindnextFloat(demfile);
    YPOS=FindnextFloat(demfile);
   sprintf(buffer1,"%.2f", XPOS);
   sprintf(buffer2,"%.2f", YPOS);
   if (in4 != 0)
     nchars = sprintf (buffer, "Easting: %s  Northing: %s\n",buffer1,buffer2);
   else
     nchars = sprintf (buffer, "Lon: %s Lat: %s\n",buffer1,buffer2);
   gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);

   if (i == 1){
	   strcpy( demid, "DEM Corner SW");
           Map->SWXPOS=XPOS; 
	   Map->SWYPOS=YPOS;}
   if (i == 2){
	   strcpy( demid, "DEM Corner NW"); 
           Map->NWXPOS=XPOS;
	   Map->NWYPOS=YPOS;}
   if (i == 3){
	   strcpy( demid, "DEM Corner NE"); 
	   Map->NEXPOS=XPOS;
	   Map->NEYPOS=YPOS;}
  if (i == 4){
	   strcpy( demid, "DEM Corner SE"); 
	   Map->SEXPOS=XPOS; 
	   Map->SEYPOS=YPOS;}
	 demlist[0]= demid;
    	 demlist[2]= buffer1;
	 demlist[1]= buffer2;
         if (in4!=0){
	   sprintf( buffer,"UTM Zone %i\n", in4);
           demlist[3]=buffer;}
         else
	   demlist[3]="arc sec\"";
	 // row=gtk_clist_append((GtkCList*) demmap, demlist);
         //gtk_clist_set_row_data((GtkCList*) demmap,row,NULL);
 }
  
  /* Find elevations */
  minelev = (int)FindnextFloat(demfile);
  Map->minelev = minelev;
  fmaxelev = FindnextFloat(demfile);
  Map->MaxElev = fmaxelev; 
  maxelev=(int)fmaxelev;
  if(fmaxelev-maxelev)
    in1=2;
  else
    in1=0;
  nchars = sprintf( buffer,"\nMinimum elevation: %i", minelev);
  //g_print("%s\n",buffer);
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);
  if(ElvUint==1){
    nchars = sprintf( buffer," feet\n");
    gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);}
  else{
    nchars = sprintf( buffer," meter\n");
    gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);}
  nchars = sprintf (buffer, "Maximum elevation: %i", maxelev);
  //g_print("%s\n",buffer);
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);
  if(ElvUint==1){
    nchars = sprintf( buffer," feet\n\n");
    gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);}
  else{
    nchars = sprintf( buffer," meter\n\n");
    gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);}

  elevrange = maxelev-minelev;

 
  /* don't need the next 2 items */
  FindnextFloat(demfile);//Counterclockwise angle 
  FindnextChar(demfile);//Acccuracy code;

  Map->spatial_resolution_x = FindnextFloatn(demfile,12);//spatial resolution x
  Map->spatial_resolution_y = FindnextFloatn(demfile,12);//spatial resolution y
  Map->spatial_resolution_z = FindnextFloatn(demfile,12);//spatial resolution z

  cur_r = FindnextInteger(demfile);// number of rows
  columns = FindnextInteger(demfile);// number of columns



/* DEM TYPE B RECORDS */
    for(i=0; i < 90; i++) 
      filename[i]=getc(demfile); 
 
    // g_print( "Writing image...");
  l = 1;
  cur_r = FindnextInteger(demfile);
  cur_c = FindnextInteger(demfile);
  rows = FindnextInteger(demfile);
  
  /*find step size of pix */
  stepsize=(int)((Map->NEXPOS-Map->NWXPOS)/columns)+1;
  
  /* this is the value to multiply elevations by to get a number between 0
     and 255 to determine the color of the pixel */
  
    colormap_scale = (float)255 / (float)elevrange;

  /* now ready to write the image data */
    
  Map->col_list_ptr = g_malloc ( (columns+1) * sizeof (col_list));
  Map->col_list_ptr[0].lsize=columns;
  Map->col_list_ptr[0].ptr=g_malloc (sizeof (row_list));
  //col_list_ptr[0].ptr[0].gc=gc[0];

  Map->col_list_ptr[0].ptr[0].z=rows;

  Map->col_list_ptr[cur_c].lsize=rows;
  
  Map->col_list_ptr[cur_c].ptr=g_malloc ( rows * sizeof (row_list));

  while(cur_c < columns) { 
    (void)FindnextInteger(demfile); PosRow=FindnextFloat(demfile);
    PosCol=FindnextFloat(demfile); (void)FindnextInteger(demfile);
    (void)FindnextInteger(demfile); (void)FindnextInteger(demfile);
   
    bottomrow =(int)(((Map->NWYPOS-Map->SWYPOS)/stepsize)+
		     ((Map->SWYPOS-PosCol)/stepsize)
		      +abs((Map->NEYPOS-Map->NWYPOS)/stepsize));
    Map->col_list_ptr[cur_c].row_offset = bottomrow;
    for(i=1; i<=rows; i++) { 
 	  
      if ((elev = (float) FindnextInteger(demfile)) ==-1) {
	sprintf(buffer,"\nError reading DEM file in\nRecord: %d Item: %d\nRecord Size: %d\n",cur_c,i,rows);
	dialog = gnome_error_dialog_parented(buffer, GTK_WINDOW(win_main));
	break;}  
      j= (elev*Map->spatial_resolution_z) - minelev;
       
      k =(float)j * colormap_scale;
      
      j= (0.12549*k)+5;
     
      if( ElvUint == 2 && Map->GUnit==2)
	h=((elev*Map->spatial_resolution_z) - minelev)
	  /Map->spatial_resolution_x; 
      else if( ElvUint == 1 && Map->GUnit==2)
	h=(elev - minelev)/(Map->spatial_resolution_x*3.28);
      else
	h=j;

    
      
     if (elev <= 0) 
	j = 0;    
      else {
        if (elev < temp && j>1 ) j = j+1;
	if (elev < 1 ) j = 1;
	if (elev > (temp+8) && j>1 ) {j =j-25;if (j<1)j=1;}
        else if (elev > (temp+3) && j>10 ) j =j-4;
	else if(elev > temp && j>1 )j =j-2;
        if (j > 255 ) j = 255;}
      temp = elev;

      

       Map->col_list_ptr[cur_c].ptr[i-1].gc=j;
      // Map->col_list_ptr[cur_c].ptr[i-1].z=h;
       Map->col_list_ptr[cur_c].ptr[i-1].z=elev - minelev;
       
    }
    if (elev == -1)
      break; 
    char_count++;
    cur_r = FindnextInteger(demfile);   
    cur_c = FindnextInteger(demfile);
    rows = FindnextInteger(demfile);
    Map->col_list_ptr[cur_c].lsize=rows;
    Map->col_list_ptr[cur_c].ptr=g_malloc ( rows * sizeof (row_list));
    
    if (rows > row1)
      row1=rows;
    gtk_progress_bar_update(GTK_PROGRESS_BAR (progressbar3),
    			    1-( (columns-char_count)/(float)columns));

    while (gtk_events_pending())
      gtk_main_iteration(); 

  }
  if (elev != -1){			 
  gtk_progress_bar_update(GTK_PROGRESS_BAR (progressbar3), 1);
  while (gtk_events_pending())
    gtk_main_iteration(); 
   
  gtk_widget_set_usize( drawingarea2, columns, row1);

  Map->col_list_ptr[0].ptr[0].z=row1+abs((Map->NEYPOS-Map->NWYPOS)/stepsize)+1;
  }
  else{
    initialize_map (data);
    Map->col_list_ptr = NULL;
    while (gtk_events_pending())
      gtk_main_iteration();}

  fclose(demfile);
 
  File2_stat = FALSE;
  gtk_text_thaw (GTK_TEXT (text2));
  return(elev);
} 



void DrawWP(gpointer data ){
   GdkRectangle update_rect;
   GtkWidget *map;
   GtkWidget *combo;
   GtkWidget *drawingarea2;
   GdkColormap *colormap;
   int ReferenceEllipsoid = 23;
   float NWXPOS, NWYPOS;
   gchar *maptext,str[30],str2[30],str3[30];
   gchar *format,latstr[20],lngstr[20];
   
   int row =0, colum =0, xpoint=0, ypoint=0, nline=0, 
       lastline=-1;
   double UTMNorthing, UTMEasting;
   char UTMZone[4]="11T" ;
   static double lat, lng;
  
   map  = get_widget ((GtkWidget *) data, "clist3");
   drawingarea2  = get_widget ((GtkWidget *) data, "drawingarea2");
   colormap = gdk_window_get_colormap (drawingarea2->window);

   // if (WPcount != 0)
   row = get_WayPoint_count(-1);

   /* GET Reference Ellipsoid */
   combo = get_widget ((GtkWidget *) data, "combo6");
   format = gtk_entry_get_text( (GtkEntry *)(GTK_COMBO (combo)->entry) );         ReferenceEllipsoid = get_ellipsoid_id ( format );

   while( gtk_clist_get_text(GTK_CLIST(map),row,colum,&maptext) != 0)
    {
  
    sscanf(maptext, "%s %s %s",str,str2,str3);
    
    /* if Waypoint is a corner positin don't do anything */
    if(strcmp(str,"DEM")==0 ||strcmp(str,"DLG")==0 ){}
    else {
        nline = atof(str3);
	gtk_clist_get_text(GTK_CLIST(map),row,1,&maptext);
	UTMNorthing=atof(maptext); sscanf(maptext, "%12c",latstr);
       	gtk_clist_get_text(GTK_CLIST(map),row,2,&maptext);
	UTMEasting=atof(maptext); sscanf(maptext, "%12c",lngstr);
	gtk_clist_get_text(GTK_CLIST(map),row,3,&maptext);
        sscanf(maptext, "%s %s %s",str,str2,UTMZone);
  
	if(strcmp(str,"degree")==0){
	  lat=UTMNorthing;
	  lng=UTMEasting;}
	else if(strcmp(str,"arc")==0){
	  remove_char_format(latstr);
	  lat=AStoDegree(latstr);
	  remove_char_format(lngstr);
	  lng=AStoDegree(lngstr);}
	else if(strcmp(str,"ddmm.mmmm'")==0){
	  remove_char_format(latstr);
	  lat=DMtoDegrees(latstr);
	  remove_char_format(lngstr);
	  lng=DMtoDegrees(lngstr);}
	else if(strcmp(str,"ddmm'ss.ss\"")==0){
	  remove_char_format(latstr);
	  lat=DMStoDegrees(latstr);
	  remove_char_format(lngstr);
	  lng=DMStoDegrees(lngstr);}
	else
	  UTMtoLL(ReferenceEllipsoid, UTMNorthing, UTMEasting, UTMZone,
		  &lat, &lng );

	if(Map->GUnit==3 && Map->col_list_ptr != NULL){
	format=toAS(lat);remove_char_format(format);lat=atof(format);
	
	ypoint= (int)((Map->NWYPOS-lat)
				    /Map->spatial_resolution_y);
	format=toAS(lng);remove_char_format(format);lng=atof(format);
	xpoint =(int)((lng-Map->NWXPOS)
				    /Map->spatial_resolution_x);
	
	 if((xpoint > 0 && ypoint >0) &&
	     (xpoint < Map->pixmap_size.x && 
	      ypoint < Map->pixmap_size.y)){
	     gtk_map_draw_rectangle    (Map,
					GetPen(drawingarea2->window,262),TRUE,
					xpoint-2,ypoint-2,
					4,4);
	     gdk_draw_rectangle    (bkpixmap,
				    GetPen(drawingarea2->window,262),TRUE,
				    xpoint-2,ypoint-2,
				    4,4);
	     gdk_draw_rectangle    (Map->pixmap,
				    GetPen(drawingarea2->window,262),TRUE,
				    xpoint-2,ypoint-2,
				    4,4);
	     update_rect.x =xpoint-2 ;
	     update_rect.y = ypoint-2;
	     update_rect.width  = 4;
	     update_rect.height = 4;

	     gtk_widget_draw (drawingarea2, &update_rect);}

	     // while (gtk_events_pending())
	     // gtk_main_iteration();
	 
	    
	}
	else if(Map->GUnit==2 && Map->col_list_ptr != NULL){ 
	  LLtoUTM( ReferenceEllipsoid, lat, lng,&UTMNorthing,
		   &UTMEasting, UTMZone);
	  format=toAS(lat);remove_char_format(format);lat=atof(format);
	  if (Map->NWXPOS >  Map->SWXPOS)
	    NWXPOS = Map->SWXPOS;
	  else
	    NWXPOS = Map->NWXPOS;

	  if (Map->NWYPOS < Map->NEYPOS)
	    NWYPOS = Map->NEYPOS;
	  else
	    NWYPOS = Map->NWYPOS;
	  ypoint= (int)((NWYPOS-UTMNorthing)
			   /Map->spatial_resolution_y);
	  format=toAS(lng);remove_char_format(format);lng=atof(format);
	  xpoint =(int)((UTMEasting-NWXPOS)
			   /Map->spatial_resolution_x);
	  
	  if((xpoint > 0 && ypoint >0)&&
	     (xpoint < Map->pixmap_size.x && 
	      ypoint < Map->pixmap_size.y)){
	  gtk_map_draw_rectangle    (Map,
				     GetPen(drawingarea2->window,262),TRUE,
				     xpoint-2,ypoint-2,
				     4,4);
	  gdk_draw_rectangle    (bkpixmap,
				 GetPen(drawingarea2->window,262),TRUE,
				 xpoint-2,ypoint-2,
				 4,4);
	  gdk_draw_rectangle    (Map->pixmap,
				 GetPen(drawingarea2->window,262),TRUE,
				 xpoint-2,ypoint-2,
				 4,4);
	 // gdk_draw_string       (bkpixmap,
	  //			 font,newgc,
	  //			 xpoint+4,ypoint,str);
	   update_rect.x =xpoint-2 ;
	   update_rect.y = ypoint-2;
	   update_rect.width  = 4;
	   update_rect.height = 4;

	   gtk_widget_draw (drawingarea2, &update_rect);}
	   
	   //while (gtk_events_pending())
	   // gtk_main_iteration(); 
	   
	}
	
    }
    lastline = nline;
    get_WayPoint_count(row);
    row++; 

    if((Map->GUnit==2 || Map->GUnit==3) && Map->col_list_ptr != NULL){
      if(imsize!=1 || flipH !=0 || flipV!=0 || rot !=0 ) 	   
	Generate_DEM(data,1,0,0,0,TRUE); 
      if(im != NULL)
	gdk_imlib_kill_image(im);im=NULL;
      im=gdk_imlib_create_image_from_drawable(Map->pixmap, 
					      Map->pixmap,0,0,
					      Map->pixmap_size.x, 
					      Map->pixmap_size.y);}
     
   
    }
   // WPcount = row; 
   while (gtk_events_pending())
      gtk_main_iteration();	  
}
 
void DLGtoIMAGE(gpointer data ) {
  GtkWidget *drawingarea2;
  GtkWidget *dialog_bar;
  GtkWidget *progressbar3;
  GdkPoint *points;
  char buffer[250],buffer1[32]="1",buffer2[32]= "2"; 
  char *str;
  char buff[10]="/n";
  char ch;
  double lat, lng;
  int nchars, nlines, row;
  FILE *demfile;
  double n1,n2,n3,n4;
  int i=0, codeF;
  long filesize=0,fcount=0,pv=0;
  char filename[145];
  GtkWidget *dlgmap, *combo;
  gchar *dlglist[4];
  gchar dlglong[64], dlglat[64], dlgzone[20], dlgid[20],
  Major_code[20], Minor_code[20];
  int ReferenceEllipsoid = 23;
  double UTMNorthing, UTMEasting;
  char UTMZone[4]="none" ;
  GdkGC *gc;
 

 
  drawingarea2  = get_widget ((GtkWidget *) data, "drawingarea2");
  dlgmap  = get_widget ((GtkWidget *) data, "clist3");
  dialog_bar  = get_widget ((GtkWidget *) data, "dialog_bar");
  progressbar3 = get_widget (dialog_bar, "progressbar3");

   /* GET Reference Ellipsoid */
  combo = get_widget ((GtkWidget *) data, "combo6");
  str = gtk_entry_get_text( (GtkEntry *)(GTK_COMBO (combo)->entry) );      
  ReferenceEllipsoid = get_ellipsoid_id ( str );

  demfile = fopen(filein, "r");
  if (demfile == NULL ){
    g_print ("Can,t open %s for reading.\n", filein);
    return;
  }
   
   while((ch = fgetc(demfile)) != EOF)
     filesize=+ftell(demfile);
   pv=filesize/100;
   rewind(demfile);
   gtk_text_freeze (GTK_TEXT (text2));

   while ((filename[i]= getc(demfile)) !=',') 
     i++; 
     filename[i] = '\0';
   for(i=strlen(filename)-2; i > 0; i--) {
    if(!isspace(filename[i])) { i=0; } else { filename[i] = '\0'; }
   nchars = sprintf (buffer,"DLG Map: %s\n", filename);
   gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);
   }

  i=0;
  while ((filename[i]= getc(demfile)) !=',') 
     i++; 
     filename[i] = '\0';
  for(i=strlen(filename)-2; i > 0; i--) {
    if(!isspace(filename[i])) { i=0; } else { filename[i] = '\0'; }
  nchars = sprintf (buffer,"%s\n\n", filename);
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);
  }

  (void) FindnextFloat(demfile);
  i=0;
  for(i=0; i < 180; i++)
      filename[i]= getc(demfile);

/* The next 19 items not used at this time   */
  for(i=0; i < 19; i++) { (void)FindnextInteger(demfile); }
 
  nchars = sprintf(buffer,"Ground coordinates of 4 corners of DLG: \n");
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);
  nchars = sprintf(buffer,"        lat:              long:            Easting:       Northing: \n");
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);

  /* get DLG File name */
  sprintf(buffer,"DLG File: %s\n",filein);
  dlglist[0]= buffer;
  dlglist[1]=" ";dlglist[2]=" ";dlglist[3]=" ";
  row=gtk_clist_append((GtkCList*) dlgmap, dlglist);
  gtk_clist_set_row_data((GtkCList*) dlgmap,row,NULL);
  for(i=1; i<=4; i++){ str = FindnextString(demfile);
                       n1 = FindnextFloat(demfile);
		       n2 = FindnextFloat(demfile);
		       n3 = FindnextFloat(demfile);
		       n4 = FindnextFloat(demfile);
	   if (i == 1){
	     strcpy( dlgid, "DLG Corner SW"); 
	     xSWc = n3;ySWc=n4;}
           if (i == 2){
	     strcpy( dlgid, "DLG Corner NW"); 
	     sprintf (buff, "%s", toAS(n2));
	     remove_char_format(buff);
	     xASNWc = atof(buff);
	     sprintf (buff, "%s", toAS(n1));
	     remove_char_format(buff);
	     yASNWc = atof(buff);
	     xNWc = n3;yNWc=n4;}
           if (i == 3){
	     strcpy( dlgid, "DLG Corner NE"); 
	     xNEc = n3;yNEc=n4;}
           if (i == 4){
	     strcpy( dlgid, "DLG Corner SE");
	     sprintf (buff, "%s", toAS(n2));
	     remove_char_format(buff);
	     xASSEc = atof(buff);
	     sprintf (buff, "%s", toAS(n1));
	     remove_char_format(buff);
	     yASSEc = atof(buff);
	     xSEc = n3;ySEc=n4;}
	   dlglist[0]= dlgid;
           sprintf (buffer1, "%s",toAS((gdouble) n1)); 
       	   dlglist[1]=  buffer1;
           sprintf (buffer2, "%s",toAS((gdouble) n2)); 
	   dlglist[2]= buffer2;
           dlglist[3]="arc sec\"";
           row=gtk_clist_append((GtkCList*) dlgmap, dlglist);
           gtk_clist_set_row_data((GtkCList*) dlgmap,row,NULL);
	   nchars =  sprintf(buffer," %12.4f  %12.4f %12.2f %12.2f %s\n", 
			     n1, n2, n3, n4, str);
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);}
  DLGUTMtoGEO(0,0,NULL,NULL,-1);
 
 /* Find DLG zone */
  LLtoUTM(ReferenceEllipsoid, (double) n1, (double) n2, 
             &UTMNorthing, &UTMEasting, UTMZone);
   nchars =  sprintf(buffer,"Zone: %s",UTMZone);
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, "\n", 1);
 
 

  /* get DLG type */
  str = FindnextString(demfile);
  if( strcmp(str,"HYDROGRAPHY")==0)
    gc = GetPen(drawingarea2->window,257);
  else  if( strcmp(str,"ROADS")==0)
    gc = GetPen(drawingarea2->window,258);
  else  if( strcmp(str,"PIPE")==0)
    gc = GetPen(drawingarea2->window,259);
  else  if( strcmp(str,"BOUNDARIES")==0)
    gc = GetPen(drawingarea2->window,260);
  else  if( strcmp(str,"PUBLIC")==0)
    gc = GetPen(drawingarea2->window,261);
  else if( strcmp(str,"HYPSOGRAPHY")==0)
    gc = GetPen(drawingarea2->window,263);
  else  gc = GetPen(drawingarea2->window,262);
  nchars =  sprintf(buffer,"DLG Type: %s\n",str);
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, buffer, nchars);
  gtk_text_insert(GTK_TEXT (text2), NULL, NULL, NULL, "\n", 1);
  dlglist[1]=" Northing ";dlglist[2]=" Easting  ";dlglist[3]=" ";
  dlglist[0]= buffer;
  gtk_clist_append((GtkCList*) dlgmap, dlglist);

/* The next 10 items are  not used at this time */
   for(i=0; i < 10; i++) {str = FindnextString(demfile);}
  
   while((ch = fgetc(demfile)) != EOF){
     
     if ( (float)ftell(demfile) > fcount){
       gtk_progress_bar_update(GTK_PROGRESS_BAR (progressbar3),
			       1-( (filesize-(float)ftell(demfile))/(float)filesize));
       while (gtk_events_pending())
	 gtk_main_iteration();
       fcount=fcount+pv;
     }

    switch(ch)
      {
      case 'A':
         sprintf (str,"UTM Zone %s\n",UTMZone );
	 strcpy( dlgzone, str); 
	 dlglist[3] = dlgzone;
	 strcpy( dlgid, FindnextString(demfile)); 
	 sprintf (str,"DLG Area %s\n",dlgid );
         strcpy( dlgid, str); 
	 dlglist[0]= dlgid;
    	 strcpy( dlglong, FindnextString(demfile)); dlglist[2]= dlglong;
	 strcpy( dlglat, FindnextString(demfile)); dlglist[1]= dlglat;
	 //row=gtk_clist_append((GtkCList*) dlgmap, dlglist);
         //gtk_clist_set_row_data((GtkCList*) dlgmap,row,NULL);
         break;
      case 'N':
         sprintf (str,"UTM Zone %s\n",UTMZone );
	 strcpy( dlgzone, str); 
	 dlglist[3] = dlgzone;
	 strcpy( dlgid, FindnextString(demfile));
	 sprintf (str,"DLG Node %s\n",dlgid );
         strcpy( dlgid, str); 
	 dlglist[0]= dlgid;
    	 strcpy( dlglong, FindnextString(demfile)); dlglist[2]= dlglong;
	 strcpy( dlglat, FindnextString(demfile)); dlglist[1]= dlglat;
	 //row=gtk_clist_append((GtkCList*) dlgmap, dlglist);
	 //gtk_clist_set_row_data((GtkCList*) dlgmap,row,NULL);
         break;
      case 'L':
         sprintf (str,"UTM Zone %s\n",UTMZone );
	 strcpy( dlgzone, str); 
	 dlglist[3] = dlgzone;
	 strcpy( dlgid, FindnextString(demfile));
	 sprintf (str,"DLG Line %s\n",dlgid );
         strcpy( dlgid, str); 
	 dlglist[0]= dlgid;
         for(i=0; i < 4; i++) { (void)FindnextInteger(demfile); }
         nlines = FindnextInteger(demfile);
         codeF=FindnextInteger(demfile);
	 (void)FindnextInteger(demfile);
	
	 points = g_malloc(nlines * sizeof (GdkPoint));
         
	 for(i=1; i <= nlines; i++){
	   UTMEasting=(double)FindnextFloat(demfile);
	   UTMNorthing=(double)FindnextFloat(demfile);
	   UTMtoLL(ReferenceEllipsoid, 
		   UTMNorthing,
		   UTMEasting,
		   UTMZone,
		   &lat, &lng );
 
	   str=toAS(lat);remove_char_format(str);lat=atof(str);
	   str=toAS(lng);remove_char_format(str);lng=atof(str);
	   points[i-1].y = (int)abs((Map->NWYPOS-lat)
				    /Map->spatial_resolution_y);
	   points[i-1].x = (int)abs((Map->NWXPOS-lng)
				    /Map->spatial_resolution_x);
     
	   /* strcpy( dlglong, FindnextString(demfile)); 
	   dlglist[2]= dlglong;
	   strcpy( dlglat, FindnextString(demfile)); 
	   dlglist[1]= dlglat;
	   if(codeF)
	   row = gtk_clist_append((GtkCList*) dlgmap, dlglist);*/
	 }
           if(codeF){
	   strcpy( Major_code, FindnextString(demfile));
           strcpy( Minor_code, FindnextString(demfile));
	   gtk_map_draw_lines (Map, gc, points, nlines);
	   }
	  
	  g_free(points); 
         break;
      default:
         break;
      }
   }
 fclose(demfile);
 gtk_widget_hide (dialog_bar);
 gtk_text_thaw (GTK_TEXT (text2));
 while (gtk_events_pending())
	 gtk_main_iteration();
 
 Generate_DEM(data,1,0,0,0,TRUE);
 push_item( NULL,"Done . . .");
return;
} 
 
void open_dxf(gpointer data)
/* **************************************************************
*  Grab all 3dfaces from a dxf file.
************************************************************** */
{
 typedef struct face { 
   float x0,y0,z0,x1,y1,z1,x2,y2,z2,x3,y3,z3;
   struct face *next;
 }face;

 face lastface;
 face *faceptr =&lastface, *tempptr;
 

  FILE *dxffile;
  GdkGC *gc;
  int i=0,j=0,n=0,tag_int,temp=0;
  int rows=1050,columns=1050;
  char buffer[64];
  double xmax=0,xmin=0,ymax=0,ymin=0,zmax=0,zmin=0,max=0,
    zoffset=0,xoffset=0,yoffset=0,K;
  gboolean keepgoing=TRUE,firsttime=TRUE;
  gc=GetPen(drawingarea2->window,260);
  
 faceptr->next=NULL; 

  dxffile=fopen(filein,"r");
   
  if(dxffile==NULL){
    g_print("Can`t open %s for reading.\n",filein);
    return;
  }
 
  while(fscanf(dxffile,"%i\n %[^\n]\n",&tag_int,buffer)!=EOF){
     if(tag_int==0 && strncasecmp(buffer,"3DFACE",6)==0){
 
  
      /* Ignore everything till tag integer 10. */
      while(tag_int!=10)
        fscanf(dxffile,"%i\n %[^\n]\n",&tag_int,buffer);
      
      /* real xyz vertex data. */
      while(keepgoing){
        switch(tag_int){
          case 10:
            sscanf(buffer,"%f",&faceptr->x0);
	    xmax=(xmax < faceptr->x0 || firsttime)? faceptr->x0:xmax;
	    xmin=(xmin > faceptr->x0 || firsttime)? faceptr->x0:xmin;
	    break;
          case 20:
            sscanf(buffer,"%f",&faceptr->y0);
	    ymax=(ymax < faceptr->y0 || firsttime)? faceptr->y0:ymax;
	    ymin=(ymin > faceptr->y0 || firsttime)? faceptr->y0:ymin;
	    break;
          case 30:
            sscanf(buffer,"%f",&faceptr->z0);
	    zmax=(zmax < faceptr->z0 || firsttime)? faceptr->z0:zmax;
	    zmin=(zmin > faceptr->z0 || firsttime)? faceptr->z0:zmin;
	    break;
          case 11:
            sscanf(buffer,"%f",&faceptr->x1);
	    xmax=(xmax < faceptr->x1 || firsttime)? faceptr->x1:xmax;
	    xmin=(xmin > faceptr->x1 || firsttime)? faceptr->x1:xmin;
	    break;
          case 21:
            sscanf(buffer,"%f",&faceptr->y1);
	    ymax=(ymax < faceptr->y1 || firsttime)? faceptr->y1:ymax;
	    ymin=(ymin > faceptr->y1 || firsttime)? faceptr->y1:ymin;
	    break;
          case 31:
            sscanf(buffer,"%f",&faceptr->z1);
	    zmax=(zmax < faceptr->z1 || firsttime)? faceptr->z1:zmax;
	    zmin=(zmin > faceptr->z1 || firsttime)? faceptr->z1:zmin;
	    break;
          case 12:
            sscanf(buffer,"%f",&faceptr->x2);
	    xmax=(xmax < faceptr->x2 || firsttime)? faceptr->x2:xmax;
	    xmin=(xmin > faceptr->x2 || firsttime)? faceptr->x2:xmin;
	    break;
          case 22:
            sscanf(buffer,"%f",&faceptr->y2);
	    ymax=(ymax < faceptr->y2 || firsttime)? faceptr->y2:ymax;
	    ymin=(ymin > faceptr->y2 || firsttime)? faceptr->y2:ymin;
	    break;
          case 32:
            sscanf(buffer,"%f",&faceptr->z2);
	    zmax=(zmax < faceptr->z2 || firsttime)? faceptr->z2:zmax;
	    zmin=(zmin > faceptr->z2 || firsttime)? faceptr->z2:zmin;
	    break;
          case 13:
            sscanf(buffer,"%f",&faceptr->x3);
	    xmax=(xmax < faceptr->x3 || firsttime)? faceptr->x3:xmax;
	    xmin=(xmin > faceptr->x3 || firsttime)? faceptr->x3:xmin;
	    break;
          case 23:
            sscanf(buffer,"%f",&faceptr->y3);
	    ymax=(ymax < faceptr->y3 || firsttime)? faceptr->y3:ymax;
	    ymin=(ymin > faceptr->y3 || firsttime)? faceptr->y3:ymin;
	    break;
          case 33:
            sscanf(buffer,"%f",&faceptr->z3);
	    zmax=(zmax < faceptr->z3 || firsttime)? faceptr->z3:zmax;
	    zmin=(zmin > faceptr->z3 || firsttime)? faceptr->z3:zmin;
            keepgoing=FALSE;
	    firsttime=FALSE;
	    break;
          default:
            break;
        }
	if (tag_int!=33)
	  fscanf(dxffile,"%i\n %[^\n]\n",&tag_int,buffer);
      }
      keepgoing=TRUE;/* reset done flag. */
      
      tempptr  = g_malloc (sizeof (face));
      tempptr->next = faceptr;;
      faceptr = tempptr;			 
     }
  }
  fclose(dxffile);
  
  /* now initailize the map data */
  g_print("% f %f %f %f %f %f\n",xmax,xmin,ymax,ymin,zmax,zmin);
  if (abs(xmax-xmin) < abs(ymax-ymin)) max=abs(ymax-ymin);
  else  max=abs(xmax-xmin);
  zoffset=1-zmin;K=200/(abs(zmax-zmin)+zoffset);
  xoffset=0-xmin+((max-abs(xmax-xmin))/2);
  yoffset=0-ymin+((max-abs(ymax-ymin))/2);
  initialize_map (data);
  Map->ElvUint = 4;
  Map->spatial_resolution_x = 1000/max;
  Map->spatial_resolution_y = 1000/max;
  Map->spatial_resolution_z = 1000/max;
  Map->col_list_ptr = g_malloc ( (columns+1) * sizeof (col_list));
  Map->col_list_ptr[0].lsize=columns;
  Map->col_list_ptr[0].ptr=g_malloc (sizeof (row_list));
  Map->col_list_ptr[0].ptr[0].z=rows;
  for(i=1; i<columns+1; i++){
    Map->col_list_ptr[i].row_offset =rows;
    Map->col_list_ptr[i].lsize= rows; 
    Map->col_list_ptr[i].ptr=g_malloc ( rows * sizeof (row_list));
    for(n=0; n<rows; n++){   
      Map->col_list_ptr[i].ptr[n].gc=-1;
      Map->col_list_ptr[i].ptr[n].z=1;
    }
  } 

  /* draw 3dfaces */
  push_item( NULL,"Generate 3D surfaces . . .");
   while (gtk_events_pending())
	 gtk_main_iteration();
  while (faceptr != NULL){
     gtk_map_draw_face (Map,gc,
	     faceptr->x0+xoffset,faceptr->y0+yoffset,faceptr->z0+zoffset, 
	     faceptr->x1+xoffset,faceptr->y1+yoffset,faceptr->z1+zoffset, 
	     faceptr->x2+xoffset,faceptr->y2+yoffset,faceptr->z2+zoffset, 
	     faceptr->x3+xoffset,faceptr->y3+yoffset,faceptr->z3+zoffset);
     tempptr = faceptr;
     faceptr = faceptr->next;
     if (faceptr != NULL)
	 free (tempptr);
  }


  /* add surface color */
  push_item( NULL,"Adding surface colors . . .");
  while (gtk_events_pending())
    gtk_main_iteration();
  for (i=1; i<=columns; i++)
    for(n=0; n<rows; n++){
      j= (Map->col_list_ptr[i].ptr[n].z/Map->spatial_resolution_z)*K;
      if (j <= 0) 
	j = -1;    
      else {
	if (j < temp && j>1 ) j = j+1;
	if (j < 2 ) j = 2;
	else if(j > temp && j>2 )j =j-2;
	if (j > 255 ) j = 255;}
      temp = j;
      Map->col_list_ptr[i].ptr[n].gc=j;}

  /* generate map */
  Generate_DEM(data,0,0,0,0,TRUE);

  push_item(NULL,"Done . . .");
  return;
}



void LoadBackground(GtkWidget *widget, gpointer data ) { 
  GtkWidget *drawingarea;
  GdkDrawable *pixmap;
  GtkWidget *entry;
  GtkWidget *  gnome_property_box;
  GtkWidget * pradiobutton1;
  char *buffer;
  drawingarea  = get_widget ((GtkWidget *) data, "pdrawingarea");
  entry  = get_widget ((GtkWidget *) data, "pentry1");
  gnome_property_box = get_widget ((GtkWidget *) data, "gnome_property_box");
  pradiobutton1 = get_widget ((GtkWidget *) data, "pradiobutton1");

  if (strstr (filein, ".xpm")!= NULL ||
      strstr (filein, ".jpg")!= NULL ||
      strstr (filein, ".tif")!= NULL ||
      strstr (filein, ".png")!= NULL ||
      strstr (filein, ".gif")!= NULL ) {
  
    while (gtk_events_pending())
	  gtk_main_iteration();
    if(Map->background !=NULL){
      gdk_imlib_kill_image(Map->background);
      Map->background=NULL;}
    push_item( NULL,"loading background . . .");
    Map->background=gdk_imlib_load_image(filein);
    gdk_imlib_render(Map->background,drawingarea->allocation.width,
		     drawingarea->allocation.height);  
    pixmap = gdk_imlib_move_image(Map->background);
    gdk_draw_pixmap    (drawingarea->window,
			drawingarea->style->white_gc,
			pixmap,
			0,0,
			0,0,
			drawingarea->allocation.width,
			drawingarea->allocation.height);
    buffer=strrchr (filein,'/');
    if(buffer){
    gtk_entry_set_text((GtkEntry *) entry,buffer+1);
    strcpy(Map->bg_str,buffer+1);}
   
    if (GTK_TOGGLE_BUTTON (pradiobutton1)->active)
       Map->bk_enable=TRUE;
    else
      Map->bk_enable=FALSE;
      
    gnome_property_box_changed((GnomePropertyBox *) gnome_property_box);}
}


void IMAGEtoBUFF(GtkWidget *widget, gpointer data ) { 
  GtkWidget *mapper;
  GtkWidget *scrolledwindow2;
  GtkWidget *drawingarea2;
  GtkWidget *pbar;
  GtkWidget *Flat_Map=NULL;
  GtkWidget *setupbutton;
 
  //GtkWidget *drawingarea2;
  GtkWidget *dialog_bar;
  gint w,h,x_size,y_size;
  gint x_pos=0,y_pos=0;
  GdkRectangle update_rect;
  int  done = FALSE, error=0;
  GtkWidget    *check_DLG;

  check_DLG = get_widget ((GtkWidget *) win_main, "glade_menuitem3");
  
  Flat_Map = get_widget((GtkWidget *) win_main,"Flat_Map");
  scrolledwindow2 = get_widget((GtkWidget *) win_main,"scrolledwindow2");
  drawingarea2 = get_widget((GtkWidget *) win_main,"drawingarea2"); 
  x_size=scrolledwindow2->allocation.width/2-118;
  y_size=scrolledwindow2->allocation.height/2-12;	 
  dialog_bar  = get_widget ((GtkWidget *) data, "dialog_bar");
  pbar = get_widget ((GtkWidget *) data, "progress_bar");
 
  gdk_window_get_origin(drawingarea2->parent->window,&x_pos,&y_pos);
  gtk_widget_set_uposition(dialog_bar, x_pos+x_size,y_pos+y_size);

  while (gtk_events_pending())
      gtk_main_iteration();

  if (strstr (filein, ".dem") != NULL ){
    if(!EnableSetupFlag && Map->col_list_ptr != NULL){
    setupbutton = get_widget ((GtkWidget *) win_main, "ExitButton");;
    gtk_button_clicked (GTK_BUTTON(setupbutton));}
    gtk_progress_bar_update(GTK_PROGRESS_BAR (pbar),0);
    gtk_widget_show (dialog_bar);
    gtk_grab_add(dialog_bar);
    while (gtk_events_pending())
      gtk_main_iteration();
    error=DEMtoIMAGE (data);
    gtk_widget_hide (dialog_bar);
    if (error !=-1)
    {
      if(GTK_CHECK_MENU_ITEM(Flat_Map)->active || NormalMode)
      {
        // check menu item "Default Map"
        gtk_check_menu_item_set_state(GTK_CHECK_MENU_ITEM(Flat_Map),TRUE);
       	if(GTK_CHECK_MENU_ITEM(check_DLG)->active)
	{
	  // check menu item DLG if not check and redraw default map
	  gtk_check_menu_item_set_state(GTK_CHECK_MENU_ITEM(check_DLG),FALSE);
	}
	else
	{
	  //else just redraw default map 
	  Generate_DEM(data,0,0,0,0,0);
        }
      }
      else
      {
        // check menu item "Default Map" and redraw default map
	gtk_check_menu_item_set_state(GTK_CHECK_MENU_ITEM(Flat_Map),TRUE);
      }
      // Set global normal mode
      NormalMode = TRUE;
    }
    gtk_grab_remove(dialog_bar);
    }
  else if (strstr (filein, ".dlg") != NULL )
    { if (Map->col_list_ptr != NULL){        
	gtk_progress_bar_update(GTK_PROGRESS_BAR (pbar),0);
	push_item( NULL,"loading DLG Map . . .");
	gtk_widget_show (dialog_bar);
	gtk_grab_add(dialog_bar);
        while (gtk_events_pending())
	  gtk_main_iteration();
        DLGtoIMAGE (data);
	gtk_grab_remove(dialog_bar);}
      else
	 push_item( NULL,"Need to load DEM Map first . . .");
    }
  else if (strstr (filein, ".log")!= NULL)
      open_log(data);
  else if (strstr (filein, ".dxf")!= NULL)
      open_dxf(data);
  else if (strstr (filein, ".xpm")!= NULL ||
	   strstr (filein, ".jpg")!= NULL ||
	   strstr (filein, ".tif")!= NULL ||
	   strstr (filein, ".png")!= NULL ||
	   strstr (filein, ".gif")!= NULL ) {
  mapper  = get_widget ((GtkWidget *) data, "Mapper");
  drawingarea2  = get_widget ((GtkWidget *) data, "drawingarea2");
  
  while (gtk_events_pending())
	  gtk_main_iteration();
  
  if ( Map->col_list_ptr != NULL)
       Map->col_list_ptr=destroy_map(Map->col_list_ptr );
  gdk_imlib_kill_image(im);im=NULL;
  push_item( NULL,"loading Map . . .");
  im=gdk_imlib_load_image(filein);
  w=im->rgb_width; h=im->rgb_height;
  gdk_imlib_render(im,w,h);  
  gdk_imlib_free_pixmap(Map->pixmap);
  Map->pixmap = gdk_imlib_move_image(im);
 
  update_rect.x = 0;
  update_rect.y = 0;
  update_rect.width  = w;
  update_rect.height  = h
;
  gtk_widget_set_usize( drawingarea2,w,h);

  gdk_draw_pixmap    (bkpixmap,
    		      drawingarea2->style->white_gc,
    		      Map->pixmap,
    		      0,0,
    		      0,0,
    		      drawingarea2->allocation.width,
    		      drawingarea2->allocation.height);

  gtk_widget_draw (drawingarea2, &update_rect); 

  button_clear_clicked(NULL, data );
 
  on_Edit_delete_activate(NULL,data);
 
  gtk_text_backward_delete(GTK_TEXT (text2),
			   gtk_text_get_length(GTK_TEXT (text2)));

  push_item( NULL,"DONE");}
  else
    push_item( NULL,"Map not found . . .");
  done = TRUE;
  gtk_widget_hide (dialog_bar);
   while (gtk_events_pending())
      gtk_main_iteration();
  return;
} 


void Start_IMAGEtoBUFF(GtkWidget *widget, gpointer data ) {

  while(gtk_events_pending())
    gtk_main_iteration();

  IMAGEtoBUFF(widget,data );
return;
}


void Save_Image(GtkWidget *button, gpointer data ) {
  GdkImlibImage *im;
  GdkImlibSaveInfo *info = NULL;
  GtkWidget *mapper;
  GtkWidget *drawingarea2;
 
  if(Map->pixmap !=NULL){
    if (strstr (filein, ".xpm")!= NULL ||
	strstr (filein, ".jpg")!= NULL ||
	strstr (filein, ".tif")!= NULL ||
	strstr (filein, ".png")!= NULL ||
	strstr (filein, ".gif")!= NULL ) {

      mapper  = get_widget ((GtkWidget *) data, "Mapper");
      drawingarea2  = get_widget ((GtkWidget *) data, "drawingarea2");
  
  
      im=gdk_imlib_create_image_from_drawable(Map->pixmap, Map->pixmap,0,0,
					  drawingarea2->allocation.width, 
					  drawingarea2->allocation.height);
 
      push_item( NULL,"Saving File....");
      while (gtk_events_pending())
	gtk_main_iteration();
  
      gdk_imlib_save_image( im, filein,info);
      gdk_imlib_kill_image(im);im=NULL;
    }
  }
  if (strstr (filein, ".log")!= NULL)
    save_log(data);
  push_item( NULL,"Done....");
  return;
} 

void ROTATEIMAGE(GtkWidget *button, gpointer data ) {
  GdkImlibImage *im;
  GtkWidget *mapper;
  GtkWidget *drawingarea2;
  gint w,h;
  GdkRectangle update_rect;

  if(Map->pixmap !=NULL){
    rot++;
    if(rot>3)
      rot=0;
    push_item( NULL,"Rotating Image Right....");
    while (gtk_events_pending())
      gtk_main_iteration();
 
    mapper  = get_widget ((GtkWidget *)  win_main, "Mapper");
    drawingarea2  = get_widget ((GtkWidget *)  win_main, "drawingarea2");
 
    update_rect.x = 0;
    update_rect.y = 0;
    update_rect.width  =  drawingarea2->allocation.width;
    update_rect.height  = drawingarea2->allocation.height;

    im=gdk_imlib_create_image_from_drawable(Map->pixmap, Map->pixmap,0,0,
					    drawingarea2->allocation.width, 
					    drawingarea2->allocation.height);
    gdk_imlib_rotate_image(im,-1);
    gdk_imlib_flip_image_horizontal(im);
    w=im->rgb_width; h=im->rgb_height;
    gdk_imlib_render(im,w,h);  
    gdk_imlib_free_pixmap(Map->pixmap);
 
    Map->pixmap = gdk_imlib_move_image(im);
    gdk_imlib_kill_image(im);im=NULL;
    gtk_widget_set_usize( drawingarea2,w,h);

    gdk_draw_pixmap    (bkpixmap,
			drawingarea2->style->white_gc,
			Map->pixmap,
			0,0,
			0,0,
			drawingarea2->allocation.width,
			drawingarea2->allocation.height);

    gtk_widget_draw (drawingarea2, &update_rect); 
    NormalMode=FALSE;
    push_item( NULL,"Done....");}
  return;
} 
  
void FLIPIMAGEVERTICAL (GtkWidget *button, gpointer data ) {
  GdkImlibImage *im;
  GtkWidget *mapper;
  GtkWidget *drawingarea2;
  gint w,h;
  GdkRectangle update_rect;

  if(Map->pixmap !=NULL){
     flipV++;
    if (flipV>1)
      flipV=0;
    push_item( NULL,"Flipping Image Vertical ....");
    while (gtk_events_pending())
      gtk_main_iteration();
 
    mapper  = get_widget ((GtkWidget *)  win_main, "Mapper");
    drawingarea2  = get_widget ((GtkWidget *)  win_main, "drawingarea2");
 
    update_rect.x = 0;
    update_rect.y = 0;
    update_rect.width  =  drawingarea2->allocation.width;
    update_rect.height  = drawingarea2->allocation.height;

    im=gdk_imlib_create_image_from_drawable(Map->pixmap, Map->pixmap,0,0,
					    drawingarea2->allocation.width, 
					    drawingarea2->allocation.height);

    gdk_imlib_flip_image_vertical(im);
    w=im->rgb_width; h=im->rgb_height;
    gdk_imlib_render(im,w,h);  
    gdk_imlib_free_pixmap(Map->pixmap);

    Map->pixmap = gdk_imlib_move_image(im);
    gdk_imlib_kill_image(im);im=NULL;
    gtk_widget_set_usize( drawingarea2,w,h);

    gdk_draw_pixmap    (bkpixmap,
			drawingarea2->style->white_gc,
			Map->pixmap,
			0,0,
			0,0,
			drawingarea2->allocation.width,
			drawingarea2->allocation.height);

    gtk_widget_draw (drawingarea2, &update_rect); 
    NormalMode=FALSE;
    push_item( NULL,"Done....");}
  return;
} 
  
void FLIPIMAGEHORIZONTAL(GtkWidget *button, gpointer data ) {
  GdkImlibImage *im;
  GtkWidget *mapper;
  GtkWidget *drawingarea2;
  gint w,h;
  GdkRectangle update_rect;
 
  if(Map->pixmap !=NULL){
    flipH++;
    if (flipH>1)
      flipH=0;
  push_item( NULL,"Flipping Image Horizontal ...");
  while (gtk_events_pending())
    gtk_main_iteration();
 
  mapper  = get_widget ((GtkWidget *)  win_main, "Mapper");
  drawingarea2  = get_widget ((GtkWidget *)  win_main, "drawingarea2");
 
  update_rect.x = 0;
  update_rect.y = 0;
  update_rect.width  =  drawingarea2->allocation.width;
  update_rect.height  = drawingarea2->allocation.height;

  im=gdk_imlib_create_image_from_drawable(Map->pixmap, Map->pixmap,0,0,
					  drawingarea2->allocation.width, 
					  drawingarea2->allocation.height);

  gdk_imlib_flip_image_horizontal(im);
  w=im->rgb_width; h=im->rgb_height;
  gdk_imlib_render(im,w,h);  
  gdk_imlib_free_pixmap(Map->pixmap);
  
  gtk_widget_set_usize( drawingarea2,w,h);
  Map->pixmap = gdk_imlib_move_image(im);
  gdk_imlib_kill_image(im);im=NULL;

  gdk_draw_pixmap    (bkpixmap,
    		      drawingarea2->style->white_gc,
    		      Map->pixmap,
    		      0,0,
    		      0,0,
    		      drawingarea2->allocation.width,
    		      drawingarea2->allocation.height);

  gtk_widget_draw (drawingarea2, &update_rect); 
  NormalMode=FALSE;
  push_item( NULL,"Done....");}
  return;
} 

void ZOOMinIMAGE(GtkWidget *button, gpointer data ) {

  GtkWidget *mapper,*map;
  GtkWidget *drawingarea2;
  GtkWidget *check_line;
  gint w,h,i;
  GdkRectangle update_rect;

  push_item( NULL,"Zooming in . . .");

  // wait for any pending events
  while (gtk_events_pending())
    gtk_main_iteration();

  map  = get_widget ((GtkWidget *)  win_main, "clist3");
  mapper  = get_widget ((GtkWidget *)  win_main, "Mapper");
  drawingarea2  = get_widget ((GtkWidget *)  win_main, "drawingarea2");
  check_line  = get_widget ((GtkWidget *) win_main, "glade_menuitem4");
  
  // is  this is a wire frame 
  if(imsize < 4  && (drawtype_motion_event == 15 || drawtype_motion_event == 14))
  { 
    imsize = imsize*2;
    if (GTK_CHECK_MENU_ITEM( check_line)->active)
      Generate_Wire_frame(Map,drawingarea2->window,Wlast_x,Wlast_y,FrameWidth, FrameHeight,
			  Step,Ax,Ay,Az,0,MapColor,(float)imsize*4);
    else
      Generate_Wire_frame(Map,drawingarea2->window,Wlast_x,Wlast_y,FrameWidth, FrameHeight,
			  Step,Ax,Ay,Az,1,MapColor,(float)imsize*4);
  }
  else if( Map->pixmap !=NULL && imsize < 1)
  {
    imsize = imsize*2;

    if (im==NULL)
      im=gdk_imlib_create_image_from_drawable(Map->pixmap, Map->pixmap,0,0,
						drawingarea2->allocation.width, 
						drawingarea2->allocation.height);


    w=im->rgb_width*imsize; h=im->rgb_height*imsize;
    gdk_imlib_render(im,w,h);  

    gdk_imlib_free_pixmap(Map->pixmap);
    Map->pixmap = gdk_imlib_move_image(im);

    gtk_widget_set_usize( drawingarea2,w,h);

    i=0; 

    gdk_draw_pixmap    (bkpixmap,
			drawingarea2->style->white_gc,
			Map->pixmap,
			0,0,
			0,0,
			drawingarea2->allocation.width,
			drawingarea2->allocation.height);

    gtk_widget_draw (drawingarea2, &update_rect); 
    NormalMode=FALSE;
  }

  push_item( NULL,"Done . . .");
  return;
}  

void ZOOMoutIMAGE(GtkWidget *button, gpointer data ) {
  
  GtkWidget *mapper,*map;
  GtkWidget *drawingarea2;
  GtkWidget *check_line;
  gint w,h,i;
  GdkRectangle update_rect;

  push_item( NULL,"Zooming out . . .");

  // wait for any pending events
  while (gtk_events_pending())
    gtk_main_iteration();

  map  = get_widget ((GtkWidget *)  win_main, "clist3");
  mapper  = get_widget ((GtkWidget *)  win_main, "Mapper");
  drawingarea2  = get_widget ((GtkWidget *)  win_main, "drawingarea2");
  check_line  = get_widget ((GtkWidget *) win_main, "glade_menuitem4");

  // is  this is a wire frame 
  if(imsize > 0.25 && (drawtype_motion_event == 15 || drawtype_motion_event == 14))
  { 
    imsize = imsize/2;
    if (GTK_CHECK_MENU_ITEM( check_line)->active)
      Generate_Wire_frame(Map,drawingarea2->window,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step,
			  Ax,Ay,Az,0,MapColor,(float)imsize*4);
    else
      Generate_Wire_frame(Map,drawingarea2->window,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step,
			  Ax,Ay,Az,1,MapColor,(float)imsize*4);
  }
  else if (imsize > 0.25 && Map->pixmap !=NULL)
  {
    imsize = imsize/2;
    if (im==NULL)
      im=gdk_imlib_create_image_from_drawable(Map->pixmap, Map->pixmap,0,0,
	                          drawingarea2->allocation.width, 
		                  drawingarea2->allocation.height);

    w=im->rgb_width*imsize ; h=im->rgb_height*imsize;
    gdk_imlib_render(im,w,h);  

    gdk_imlib_free_pixmap(Map->pixmap);

    Map->pixmap = gdk_imlib_move_image(im);

    gtk_widget_set_usize( drawingarea2,w,h);
  
    i=0;  

    gdk_draw_pixmap    (bkpixmap,
			drawingarea2->style->white_gc,
			Map->pixmap,
			0,0,
			0,0,
			drawingarea2->allocation.width,
			drawingarea2->allocation.height);

    gtk_widget_draw (drawingarea2, &update_rect); 
    NormalMode=FALSE;
  }

  push_item( NULL,"Done . . .");
  return;
}  

void
initialize_map (gpointer  data)
{
  GtkWidget *drawingarea2;
  GtkWidget *notebook2;
  GdkRectangle update_rect;
  
  drawingarea2  = get_widget ((GtkWidget *) data, "drawingarea2");
  notebook2  = get_widget ((GtkWidget *) data, "notebook2");
 
   
   while (gtk_events_pending())
    gtk_main_iteration();
   get_WayPoint_count(0);
   if (Map->pixmap){   
     gdk_imlib_free_pixmap(Map->pixmap);
     if (im !=NULL)
       gdk_imlib_kill_image(im);
     im=NULL;
    
 
     update_rect.x = 0;
     update_rect.y = 0;
     update_rect.width  =  drawingarea2->allocation.width;
     update_rect.height  = drawingarea2->allocation.height;
     gdk_draw_rectangle (bkpixmap,
			 drawingarea2->style->white_gc,
			 TRUE,0,0,
			 drawingarea2->allocation.width,
			 drawingarea2->allocation.height);

 
     Map->pixmap = gdk_pixmap_new(drawingarea2->window,
			       drawingarea2->allocation.width,
			       drawingarea2->allocation.height,
			       -1);
     gdk_draw_rectangle ( Map->pixmap,
			 drawingarea2->style->white_gc,
			 TRUE,0,0,
			 drawingarea2->allocation.width,
			 drawingarea2->allocation.height);

     button_clear_clicked(NULL, data );
 
    
     on_Edit_delete_activate(NULL,data);
 
   
     if ( Map->col_list_ptr != NULL){
       Map->col_list_ptr=destroy_map(Map->col_list_ptr );}
 
     gtk_text_backward_delete(GTK_TEXT (text2),
			      gtk_text_get_length(GTK_TEXT (text2)));
     
   }
 
  push_item( NULL,"Done");

  return; 
}

void
on_new_activate                  (GtkWidget    *widget,
					gpointer         data)
{
 
  push_item( NULL,"Initializing Map. . .");

  initialize_map (data);
  gdk_draw_rectangle ( drawingarea2->window,
		       drawingarea2->style->white_gc,
		      TRUE,
		      0, 0,
		       drawingarea2->allocation.width,
		       drawingarea2->allocation.height);
 
  return; 
}



void
on_File2_open_activate                  (GtkWidget    *widget,
					gpointer         data)
{
  GtkWidget *fileselection1; 
 
  fileselection1 = create_fileselection1();
  gtk_grab_add(fileselection1);

 data=(gpointer) win_main;

 push_item( NULL,"Select File....");
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->cancel_button ),	     
			     "clicked", (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (fileselection1));

  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button ),
		      "clicked", (GtkSignalFunc) set_filein,
		      fileselection1);

     gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button ),
 		       "clicked",  GTK_SIGNAL_FUNC (push_item),
 		       "Loading MAP File . . .");

     gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button ),
			 "clicked", (GtkSignalFunc) Start_IMAGEtoBUFF ,
			 data); 

 
    gtk_signal_connect_object ( GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button),
   			     "clicked", (GtkSignalFunc) gtk_widget_destroy,
   			     GTK_OBJECT (fileselection1));

 gtk_widget_show (fileselection1);



 return; 
}

void
on_File_open_background_activate       (GtkWidget    *widget,
					gpointer         data)
{
  GtkWidget *fileselection1; 
 
  fileselection1 = create_fileselection1();
  gtk_grab_add(fileselection1);

 data=(gpointer) win_main;

 push_item( NULL,"Select File....");
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->cancel_button ),	     
			     "clicked", (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (fileselection1));

  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button ),
		      "clicked", (GtkSignalFunc) set_filein,
		      fileselection1);

     gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button ),
 		       "clicked",  GTK_SIGNAL_FUNC (push_item),
 		       "Loading MAP File . . .");

     gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button ),
			 "clicked", (GtkSignalFunc) LoadBackground,
			 data); 

 
    gtk_signal_connect_object ( GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button),
   			     "clicked", (GtkSignalFunc) gtk_widget_destroy,
   			     GTK_OBJECT (fileselection1));

 gtk_widget_show (fileselection1);



 return; 
}

void
on_File1_open__activate                  (GtkWidget    *widget,
					gpointer         data)
{
  gtk_signal_connect (GTK_OBJECT (widget ), "activate",
		      GTK_SIGNAL_FUNC (push_item),
 		      "Select File");
  on_File2_open_activate                  (widget,data);

return;
  }


void
on_File2_save_activate                  (GtkWidget    *widget,
					gpointer         data)
{
  GtkWidget *fileselection1; 
  data=(gpointer) win_main;
  fileselection1 = create_fileselection1();
  gtk_grab_add( fileselection1);
  push_item( NULL,"Select File....");
 
 gtk_file_selection_set_filename(GTK_FILE_SELECTION (fileselection1),
				 "unknownmap.png");

  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->cancel_button ),
			     "clicked", (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (fileselection1));

 gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button ),
			    "clicked", (GtkSignalFunc) set_filein,
			     fileselection1);


 gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button ),
		     "clicked", (GtkSignalFunc) Save_Image ,
		      data ); 

 gtk_signal_connect_object ( GTK_OBJECT (GTK_FILE_SELECTION (fileselection1)->ok_button),
			     "clicked", (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (fileselection1));

 gtk_widget_show (fileselection1);

 return;
}

void
on_File1_save_activate                  (GtkWidget    *widget,
					gpointer         data)
{
  gtk_signal_connect (GTK_OBJECT (widget ), "activate",
		      GTK_SIGNAL_FUNC (push_item),
 		      "Select File");
  on_File2_save_activate                  (widget,data);

return;
  }


void
on_Map_Flat_activate                  (GtkWidget    *widget,
					gpointer         data)
{ 
  GtkWidget    *check_DLG;

  check_DLG = get_widget ((GtkWidget *) win_main, "glade_menuitem3");

  if ( Map->col_list_ptr != NULL && !NormalMode)
  {
    imsize=1;flipH=0;flipV=0;rot=0;
    if(GTK_CHECK_MENU_ITEM(check_DLG)->active)
      gtk_check_menu_item_set_state(GTK_CHECK_MENU_ITEM(check_DLG),FALSE);
    else
      Generate_DEM(data,0,0,0,0,0);
  }
  else 
    push_item( NULL,"DEM not loaded . . .");

  NormalMode=TRUE;
}

void
on_Map_normal_activate                  (GtkWidget    *widget,
					gpointer         data)
{ 

  if ( Map->col_list_ptr != NULL)
  {
    if(drawtype_motion_event == 15 || drawtype_motion_event == 14)
    {
      Ax=0; Ay=0;
      Wlast_x=0; Wlast_y=0;
      Generate_DEM(data,0,0,0,0,1); 
    }
    else if(!NormalMode)
    { 
      imsize=1;flipH=0;flipV=0;rot=0;
      Generate_DEM(data,0,0,0,0,0);
      NormalMode=TRUE;
    }
  }
  else
    push_item( NULL,"DEM not loaded . . .");
}

void
on_Map_DLG_activate                  (GtkWidget    *widget,
					gpointer         data)
{ 
  GtkWidget *Flat_Map;

  Flat_Map = get_widget((GtkWidget *) win_main,"Flat_Map");

  if ( Map->col_list_ptr != NULL)
  { 
    if(drawtype_motion_event == 15 || drawtype_motion_event == 14)
    { 
      Generate_DEM(data,0,0,0,0,1);
    }
    else
    {
      imsize=1;flipH=0;flipV=0;rot=0;
      if(GTK_CHECK_MENU_ITEM(Flat_Map)->active)
	Generate_DEM(data,0,0,0,0,0);
      else
	Generate_DEM(data,2,0,0,0,1);
    }
  }
  else
    push_item( NULL,"DEM not loaded . . .");
  NormalMode=FALSE;
}

void
on_Map_line_activate                  (GtkWidget    *widget,
					gpointer         data)
{ 
  GtkRequisition Requisition;
  // GtkAdjustment* vadjustment;
  // GtkAdjustment* hadjustment;
  GtkWidget *drawingarea2;
  GtkWidget *hpaned3;
  GtkScrolledWindow *scrolled_window;
  

  drawingarea2= get_widget ((GtkWidget *) win_main, "drawingarea2");
  hpaned3 = get_widget ((GtkWidget *) win_main, "hpaned3");
  scrolled_window= GTK_SCROLLED_WINDOW ( get_widget ((GtkWidget *) win_main, "scrolledwindow2"));
  gtk_widget_size_request(hpaned3,&Requisition);
		 
  if ( Map->col_list_ptr != NULL)
  {
    if(drawtype_motion_event == 15 || drawtype_motion_event == 14)
    {
      // generate map
      Generate_DEM(data,0,0,0,0,1); 
      // center scroll bars
      /*vadjustment=gtk_scrolled_window_get_vadjustment(scrolled_window);
      gtk_adjustment_set_value(vadjustment,(Map->pixmap_size.y-Requisition.height)/2);
      hadjustment=gtk_scrolled_window_get_hadjustment(scrolled_window);
      gtk_adjustment_set_value(hadjustment,(Map->pixmap_size.x-Requisition.width)/2);*/
    }
    else
    {
      imsize=1;flipH=0;flipV=0;rot=0;
      Generate_DEM(data,0,0,0,0,1);
    }
  }
  else
    push_item( NULL,"DEM not loaded . . .");
 
}


void
on_Map_3D_activate                  (GtkWidget    *widget,
					gpointer         data)
{ 

  if ( Map->col_list_ptr != NULL)
  {
    if(drawtype_motion_event == 15 || drawtype_motion_event == 14)
    {
      Ax=30, Ay=60;
      Generate_DEM(data,0,0,0,0,0);
    }
    else
    {
      imsize=1;flipH=0;flipV=0;rot=0;
      Generate_DEM(data,1,30,60,0,0);
      NormalMode=FALSE;
    }
  }
  else
    push_item( NULL,"DEM not loaded . . .");
 
}

gint Generate_DEM(gpointer data,int ty,double xx,double yy,double zz
		 , int enable)
{
  GdkRectangle update_rect;
  GtkWidget *check_line;
  GtkWidget *check_line3;
  
  static double Axx,Ayy,Azz;
  static int type = 0;

  if ( enable == FALSE){
    Axx=xx;Ayy=yy;Azz=zz;type=ty;
  }

  check_line  = get_widget ((GtkWidget *) data, "glade_menuitem4");
  check_line3  = get_widget ((GtkWidget *) data, "glade_menuitem3");

  // is  this is a wire frame set this to wire mode
  if(drawtype_motion_event == 15 || drawtype_motion_event == 14)
  { 
    if (GTK_CHECK_MENU_ITEM( check_line3)->active)
       MapColor = TRUE;
    else
       MapColor = FALSE;
    
    if (GTK_CHECK_MENU_ITEM( check_line)->active)
      Generate_Wire_frame(Map,bkpixmap,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step,Ax,Ay,Az,
			  0,MapColor,(float)imsize*4);
    else
      Generate_Wire_frame(Map,bkpixmap,Wlast_x,Wlast_y,FrameWidth, FrameHeight,Step,Ax,Ay,Az,
			  1,MapColor,(float)imsize*4);
  }
  else
  {
    if (GTK_CHECK_MENU_ITEM( check_line)->active)
      type=type|0x0100;
    else
      type=type & 0xf0ff;

    if (GTK_CHECK_MENU_ITEM( check_line3)->active)
      type=type|0x0002;
    else
      type=type & 0xfffd;
  

    imsize=1;flipH=0;flipV=0;rot=0;
 
    gtk_widget_set_sensitive( get_menu_widget(0),FALSE);
    gtk_widget_set_sensitive( get_menu_widget(1),FALSE);
    gtk_widget_set_sensitive( get_toolbar_widget(0),FALSE);
    gtk_widget_set_sensitive( get_toolbar_widget(1),FALSE);
    gtk_widget_set_sensitive( get_toolbar_widget(2),FALSE);
    gtk_widget_set_sensitive( get_toolbar_widget(3),FALSE);

    /* gtk_widget_set_sensitive( get_toolbar_widget(4),FALSE);
      gtk_widget_set_sensitive( get_toolbar_widget(5),FALSE);
      gtk_widget_set_sensitive( get_toolbar_widget(6),FALSE);*/
    gtk_widget_set_sensitive(drawingarea2,FALSE);

    if(im != NULL)
      gdk_imlib_kill_image(im);im=NULL;

    push_item( NULL,"Generating DEM Map....");  

    if(Map->pixmap) 
      gdk_imlib_free_pixmap(Map->pixmap);

    gtk_Generate_Image(Map,drawingarea2->window,type,Axx,Ayy,Azz);
 
    gtk_widget_set_usize( drawingarea2, Map->pixmap_size.x, Map->pixmap_size.y);
      
    gdk_draw_pixmap    (bkpixmap,
			drawingarea2->style->white_gc,
			Map->pixmap,
			0,0,
			0,0,
			drawingarea2->allocation.width,
			drawingarea2->allocation.height);

    im=gdk_imlib_create_image_from_drawable(Map->pixmap, Map->pixmap,0,0,
					    Map->pixmap_size.x, 
					    Map->pixmap_size.y);
  }

  push_item( NULL,"DONE");

  update_rect.x =0 ;
  update_rect.y = 0;
  update_rect.width  = drawingarea2->allocation.width;
  update_rect.height  = drawingarea2->allocation.height;

  gtk_widget_draw (drawingarea2, &update_rect);

  
  
  gtk_widget_set_sensitive( get_menu_widget(0),TRUE);
  gtk_widget_set_sensitive( get_menu_widget(1),TRUE);
  gtk_widget_set_sensitive( get_toolbar_widget(0),TRUE);
  gtk_widget_set_sensitive( get_toolbar_widget(1),TRUE);
  gtk_widget_set_sensitive( get_toolbar_widget(2),TRUE);
  gtk_widget_set_sensitive( get_toolbar_widget(3),TRUE);
  
  /* gtk_widget_set_sensitive( get_toolbar_widget(4),TRUE);
  gtk_widget_set_sensitive( get_toolbar_widget(5),TRUE);
  gtk_widget_set_sensitive( get_toolbar_widget(6),TRUE);*/

  gtk_widget_set_sensitive(drawingarea2,TRUE);

  while (gtk_events_pending())
    gtk_main_iteration();
 
 

  return TRUE;
}


/* This function is used to find a child widget from a parent */
GtkWidget*
get_widget                             (GtkWidget       *widget,
                                        gchar           *widget_name)
{
  GtkWidget *found_widget;

  if (widget->parent)
    widget = gtk_widget_get_toplevel (widget);
  found_widget = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (widget),
                                                   widget_name);
  if (!found_widget)
    g_warning ("Widget not found: %s", widget_name);
  return found_widget;
}


/* This is an internally used function to set notebook tab widgets. */
void
set_notebook_tab                       (GtkWidget       *notebook,
                                        gint             page_num,
                                        GtkWidget       *widget)
{
  GtkNotebookPage *page;
  GtkWidget *notebook_page;

  page = (GtkNotebookPage*) g_list_nth (GTK_NOTEBOOK (notebook)->children, page_num)->data;
  notebook_page = page->child;
  gtk_widget_ref (notebook_page);
  gtk_notebook_remove_page (GTK_NOTEBOOK (notebook), page_num);
  gtk_notebook_insert_page (GTK_NOTEBOOK (notebook), notebook_page,
                            widget, page_num);
  gtk_widget_unref (notebook_page);
}


/*
 * create_Mapper
 *
 */

GtkWidget*
create_Mapper ()
{
  GtkWidget *Mapper;
  GtkWidget *packer5;
  GtkWidget *combo6;
  GList *combo6_items = NULL;
  GtkWidget *notebook2;
  GtkWidget *frame6;
  GtkWidget *fixed8;
  GtkWidget *entry4;
  GtkWidget *entry5;
  GtkWidget *entry6;
  GtkWidget *entry7;
  GSList *fixed8_group = NULL;
  GtkWidget *radiobutton1;
  GtkWidget *radiobutton2;
  GtkWidget *radiobutton3;
  GtkWidget *radiobutton4;
  GtkWidget *radiobutton5;
  GtkWidget *hbuttonbox1;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *button3;
  GtkWidget *hseparator1;
  GtkWidget *packer7;
  GtkWidget *frame10;
  GtkWidget *fixed9;
  GtkWidget *label5;
  GdkPixmap *glade_pixmap;
  GdkBitmap *glade_mask;
  GtkWidget *pixmap1;
  GtkWidget *Lmap1,*Lmap2,*Lmap3;
  GtkWidget *label3,*label13;
  GtkWidget *label4,*label14;
  GtkWidget *frame9;
  GtkWidget *label2;
  GtkWidget *clist3, *tmplist;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *label8;
  GtkWidget *label9;
  GtkWidget *label15;
  GtkWidget *label16;
  GtkWidget *hbox1;  
  GtkWidget *hbox2; 
  GtkWidget *hpaned3;
  GtkWidget *frame8;
  GtkWidget *packer11;

  GtkWidget *hbox;
  GtkWidget* dialog_bar;
  GtkWidget* colorarea;

  GtkWidget *scrolledwindow; 
  GtkWidget *scrolledwindow2;
  GtkWidget *scrolledwindow3;

  char LABEL[100];
  char buff[20];

  /*** gnome-widgets */
   Mapper = gnome_app_new(PACKAGE, _("g3DGMV"));

 
  win_main=Mapper;
  gtk_object_set_data (GTK_OBJECT (Mapper), "Mapper", Mapper);

  gtk_window_set_policy (GTK_WINDOW (Mapper),TRUE,TRUE, FALSE);
  

  accel_group = gtk_accel_group_new();
  gtk_accel_group_attach(accel_group, GTK_OBJECT(Mapper));
  dialog_bar = create_dialog_bar ();
  popup_menu=create_popup_menu (win_main);
  gtk_window_set_transient_for( GTK_WINDOW(dialog_bar),GTK_WINDOW (Mapper));
 

  gtk_object_set_data (GTK_OBJECT (Mapper), "dialog_bar", dialog_bar);
  
  packer5 = gtk_packer_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "packer5", packer5);
  gtk_widget_show (packer5);
  gnome_app_set_contents(GNOME_APP(Mapper),  packer5);
 
  statusbar3 = gnome_appbar_new(TRUE, TRUE, GNOME_PREFERENCES_NEVER);

  gnome_app_set_statusbar(GNOME_APP(Mapper), statusbar3);

  install_menus_and_toolbar(Mapper);
  

  /* create the combo box for Ellipsoids */
  combo6 = gtk_combo_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "combo6", combo6);
  gtk_widget_show (combo6);
 
  gtk_widget_set_usize (GTK_COMBO (combo6)->entry, 159, 22);
  gtk_widget_set_usize (combo6, 170, 22);
  combo6_items = g_list_append (combo6_items, "None");
  combo6_items = g_list_append (combo6_items, "Airy");
  combo6_items = g_list_append (combo6_items, "Australian National");
  combo6_items = g_list_append (combo6_items, "Bessel 1841");
  combo6_items = g_list_append (combo6_items, "Bessel 1841 (Nambia)");
  combo6_items = g_list_append (combo6_items, "Clarke 1866");
  combo6_items = g_list_append (combo6_items, "Clarke 1880");
  combo6_items = g_list_append (combo6_items, "Everest");
  combo6_items = g_list_append (combo6_items, "Fischer 1960 (Mercury)");
  combo6_items = g_list_append (combo6_items, "Fischer 1968");
  combo6_items = g_list_append (combo6_items, "GRS 1967");
  combo6_items = g_list_append (combo6_items, "GRS 1980");
  combo6_items = g_list_append (combo6_items, "Helmert 1906");
  combo6_items = g_list_append (combo6_items, "Hough");
  combo6_items = g_list_append (combo6_items, "International");
  combo6_items = g_list_append (combo6_items, "Krassovsky");
  combo6_items = g_list_append (combo6_items, "Modified Airy");
  combo6_items = g_list_append (combo6_items, "Modified Everest");
  combo6_items = g_list_append (combo6_items, "Modified Fischer 1960");
  combo6_items = g_list_append (combo6_items, "South American 1969");
  combo6_items = g_list_append (combo6_items, "WGS-60");
  combo6_items = g_list_append (combo6_items, "WGS-66");
  combo6_items = g_list_append (combo6_items, "WGS-72");
  combo6_items = g_list_append (combo6_items, "WGS-84");

  gtk_combo_set_popdown_strings (GTK_COMBO (combo6), combo6_items);
  g_list_free (combo6_items);
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo6)->entry),"Clarke 1866");
  

  notebook2 = gtk_notebook_new ();
  
  gtk_object_set_data (GTK_OBJECT (Mapper), "notebook2", notebook2);
  gtk_widget_show (notebook2);
  gtk_packer_add (GTK_PACKER (packer5), notebook2, GTK_SIDE_TOP,
                  GTK_ANCHOR_WEST, GTK_PACK_EXPAND | GTK_FILL_X | GTK_FILL_Y,
                  0, 0, 0, 0, 0);
  gtk_widget_set_usize (notebook2, 636, 88);
  gtk_container_border_width (GTK_CONTAINER (notebook2), 3);
 
  frame6 = gtk_frame_new (NULL);
  gtk_object_set_data (GTK_OBJECT (Mapper), "frame6", frame6);
  gtk_widget_show (frame6);
  gtk_container_add (GTK_CONTAINER (notebook2), frame6);

  fixed8 = gtk_fixed_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "fixed8", fixed8);
  gtk_widget_show (fixed8);
  gtk_container_add (GTK_CONTAINER (frame6), fixed8);

  entry4 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "entry4", entry4);
  gtk_widget_show (entry4);
  gtk_fixed_put (GTK_FIXED (fixed8), entry4, 100, 16);
  gtk_widget_set_usize (entry4, 165, 22);

  entry5 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "entry5", entry5);
  gtk_widget_show (entry5);
  gtk_fixed_put (GTK_FIXED (fixed8), entry5, 100, 56);
  gtk_widget_set_usize (entry5, 165, 22);

  entry6 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "entry6", entry6);
  gtk_widget_show (entry6);
  gtk_fixed_put (GTK_FIXED (fixed8), entry6, 100, 96);
  gtk_widget_set_usize (entry6, 165, 22);

  gtk_editable_delete_text(GTK_EDITABLE  (entry4),0,-1);
  gtk_editable_delete_text(GTK_EDITABLE  (entry5),0,-1);
  gtk_editable_delete_text(GTK_EDITABLE  (entry6),0,-1);
 

  /*The Selection buttons for GLOBAL Position Format */

  radiobutton1 = gtk_radio_button_new_with_label (fixed8_group, "ddmm.mmmm'");
  fixed8_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));
  gtk_object_set_data (GTK_OBJECT (Mapper), "radiobutton1", radiobutton1);
  gtk_widget_show (radiobutton1);
  gtk_fixed_put (GTK_FIXED (fixed8), radiobutton1, 288, 24);
  gtk_widget_set_usize (radiobutton1, 99, 24);
  gtk_signal_connect (GTK_OBJECT (radiobutton1), "clicked",
		      GTK_SIGNAL_FUNC (button_DDMM_format), 
		      (gpointer) Mapper); 

  radiobutton2 = gtk_radio_button_new_with_label (fixed8_group, 
						  "ddmm'ss.ss\"");
  fixed8_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
  gtk_object_set_data (GTK_OBJECT (Mapper), "radiobutton2", radiobutton2);
  gtk_widget_show (radiobutton2);
  gtk_fixed_put (GTK_FIXED (fixed8), radiobutton2, 288, 56);
  gtk_widget_set_usize (radiobutton2, 99, 24);
  gtk_signal_connect (GTK_OBJECT (radiobutton2), "clicked",
		      GTK_SIGNAL_FUNC (button_DDMMSS_format), 
		      (gpointer) Mapper); 


  radiobutton3 = gtk_radio_button_new_with_label (fixed8_group, "degrees");
  fixed8_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton3));
  gtk_object_set_data (GTK_OBJECT (Mapper), "radiobutton3", radiobutton3);
  gtk_widget_show (radiobutton3);
  gtk_fixed_put (GTK_FIXED (fixed8), radiobutton3, 288, 88);
  gtk_widget_set_usize (radiobutton3, 99, 24);
  gtk_signal_connect (GTK_OBJECT (radiobutton3), "clicked",
		      GTK_SIGNAL_FUNC (button_DEGREES_format),
		      (gpointer) Mapper); 

  radiobutton4 = gtk_radio_button_new_with_label (fixed8_group, "arc sec");
  fixed8_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton4));
  gtk_object_set_data (GTK_OBJECT (Mapper), "radiobutton4", radiobutton4);
  gtk_widget_show (radiobutton4);
  gtk_fixed_put (GTK_FIXED (fixed8), radiobutton4, 387, 24);
  gtk_widget_set_usize (radiobutton4, 99, 24);
  gtk_signal_connect (GTK_OBJECT (radiobutton4), "clicked",
		      GTK_SIGNAL_FUNC (button_arc_seconds_format),
		      (gpointer) Mapper); 

  radiobutton5 = gtk_radio_button_new_with_label (fixed8_group, "UTM");
  fixed8_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton5));
  gtk_object_set_data (GTK_OBJECT (Mapper), "radiobutton5", radiobutton5);
  gtk_widget_show (radiobutton5);
  gtk_fixed_put (GTK_FIXED (fixed8), radiobutton5, 387, 56);
  gtk_widget_set_usize (radiobutton5, 99, 24);
  gtk_signal_connect (GTK_OBJECT (radiobutton5), "clicked",
                     GTK_SIGNAL_FUNC (button_UTM_format), 
		     (gpointer) Mapper); 

  entry7 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "entry7", entry7);
  gtk_widget_show (entry7);
  gtk_fixed_put (GTK_FIXED (fixed8), entry7, 387, 88 );
  gtk_widget_set_usize (entry7, 35, 22);

  label15 = gtk_label_new ("Zone");
  gtk_object_set_data (GTK_OBJECT (Mapper), "label15", label15);
  gtk_widget_show (label15);
  gtk_fixed_put (GTK_FIXED (fixed8), label15, 425, 90);
  gtk_widget_set_usize (label15, 32, 16);
  gtk_label_set_justify (GTK_LABEL (label15), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label15), 1, 0.5);
                                      
  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "hbuttonbox1", hbuttonbox1);
  gtk_widget_show (hbuttonbox1);
  gtk_fixed_put (GTK_FIXED (fixed8), hbuttonbox1, 200, 152);
  gtk_widget_set_usize (hbuttonbox1, 279, 27);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox1), 45);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox1), 63, 27);
  gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox1), 0, 0);
  
 

  button1 = gtk_button_new_with_label ("Acquire");
  gtk_object_set_data (GTK_OBJECT (Mapper), "button1", button1);
  gtk_widget_show (button1);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button1);

  button2 = gtk_button_new_with_label ("Clear");
  gtk_object_set_data (GTK_OBJECT (Mapper), "button2", button2);
  gtk_widget_show (button2);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button2);
  gtk_signal_connect (GTK_OBJECT (button2), "clicked",
                      GTK_SIGNAL_FUNC (button_clear_clicked),
                      (gpointer) Mapper);

  button3 = gtk_button_new_with_label ("Add");
  gtk_object_set_data (GTK_OBJECT (Mapper), "button3", button3);
  gtk_widget_show (button3);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button3);

  gtk_signal_connect (GTK_OBJECT (button3), "clicked",
                      GTK_SIGNAL_FUNC (button_add_clicked),
                      (gpointer) Mapper);
  

  hseparator1 = gtk_hseparator_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "hseparator1", hseparator1);
  gtk_widget_show (hseparator1);
  gtk_fixed_put (GTK_FIXED (fixed8), hseparator1, 10, 128);
  gtk_widget_set_usize (hseparator1, 478, 22);

  packer7 = gtk_packer_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "packer7", packer7);
  gtk_widget_show (packer7);
  gtk_fixed_put (GTK_FIXED (fixed8), packer7, 32, 72);
  gtk_widget_set_usize (packer7, 0, 0);

  frame10 = gtk_frame_new (NULL);
  gtk_object_set_data (GTK_OBJECT (Mapper), "frame10", frame10);
  gtk_widget_show (frame10);
  gtk_fixed_put (GTK_FIXED (fixed8), frame10, 184, 192);
  gtk_widget_set_usize (frame10, 304, 80);

  fixed9 = gtk_fixed_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "fixed9", fixed9);
  gtk_widget_show (fixed9);
  gtk_container_add (GTK_CONTAINER (frame10), fixed9);

  sprintf(LABEL, "g3DGMV %s\nGNU 3D Graphical Map Viewer ", VERSION);
  label5 = gtk_label_new (LABEL);
   
  gtk_object_set_data (GTK_OBJECT (Mapper), "label5", label5);
  gtk_widget_show (label5);
  gtk_fixed_put (GTK_FIXED (fixed9), label5, 16, 16);
  gtk_widget_set_usize (label5, 271, 46);

  gtk_widget_realize (Mapper);
  glade_pixmap = gdk_pixmap_create_from_xpm_d (Mapper->window, &glade_mask,
                                             &Mapper->style->bg[GTK_STATE_NORMAL],
                                             world_xpm);
 
  pixmap1 = gtk_pixmap_new (glade_pixmap, glade_mask);
  gdk_pixmap_unref (glade_pixmap);
  gdk_bitmap_unref (glade_mask);
  gtk_object_set_data (GTK_OBJECT (Mapper), "pixmap1", pixmap1);
  gtk_widget_show (pixmap1);
  gtk_fixed_put (GTK_FIXED (fixed8), pixmap1, 24, 144);
  gtk_widget_set_usize (pixmap1, 131, 131);

  label3 = gtk_label_new  ("Latitude or   ");
  label13 = gtk_label_new ("UTM Northing: ");
  gtk_object_set_data (GTK_OBJECT (Mapper), "label3", label3);
  gtk_object_set_data (GTK_OBJECT (Mapper), "label13", label13);
  gtk_widget_show (label3);
  gtk_widget_show (label13);
  gtk_fixed_put (GTK_FIXED (fixed8), label3, 0, 52);
  gtk_fixed_put (GTK_FIXED (fixed8), label13, 0, 64);
  gtk_widget_set_usize (label3, 98, 16);
  gtk_widget_set_usize (label13, 98, 16);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);
  gtk_label_set_justify (GTK_LABEL (label13), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label3), 1, 0.5);
  gtk_misc_set_alignment (GTK_MISC (label13), 1, 0.5);

  label4 = gtk_label_new  ("Longitude or ");
  label14 = gtk_label_new ("UTM Easting: ");
  gtk_object_set_data (GTK_OBJECT (Mapper), "label4", label4);
  gtk_object_set_data (GTK_OBJECT (Mapper), "label14", label14);
  gtk_widget_show (label4);
  gtk_widget_show (label14);
  gtk_fixed_put (GTK_FIXED (fixed8), label4, 0, 92);
  gtk_fixed_put (GTK_FIXED (fixed8), label14, 0, 104);
  gtk_widget_set_usize (label4, 98, 16);
  gtk_widget_set_usize (label14, 98, 16);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_RIGHT);
  gtk_label_set_justify (GTK_LABEL (label14), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label4), 1, 0.5);
  gtk_misc_set_alignment (GTK_MISC (label14), 1, 0.5);

  frame9 = gtk_frame_new ("Format");
  gtk_object_set_data (GTK_OBJECT (Mapper), "frame9", frame9);
  gtk_widget_show (frame9);
  gtk_fixed_put (GTK_FIXED (fixed8), frame9, 280, 8);
  gtk_widget_set_usize (frame9, 208, 112);

  label2 = gtk_label_new ("Waypoint\n Name:");
  gtk_object_set_data (GTK_OBJECT (Mapper), "label2", label2);
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fixed8), label2, 0, 10);
  gtk_widget_set_usize (label2, 90, 30);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label2), 1, 0.5);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (Mapper), "scrolledwindow3",
		       scrolledwindow3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3),
				  GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrolledwindow3);

  gtk_container_add (GTK_CONTAINER (notebook2), scrolledwindow3);
  clist3 = gtk_clist_new (4);
  gtk_object_set_data (GTK_OBJECT (Mapper), "clist3", clist3);
  gtk_widget_show (clist3);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), clist3);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 0, 120);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 1, 100);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 2, 100);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 3, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist3));
 
  /*-- a list to hold the temp information --*/
  tmplist= gtk_clist_new (4);
  gtk_object_set_data (GTK_OBJECT (Mapper), "tmplist", tmplist);
  gtk_clist_set_column_width (GTK_CLIST (tmplist), 0, 120);
  gtk_clist_set_column_width (GTK_CLIST (tmplist), 1, 100);
  gtk_clist_set_column_width (GTK_CLIST (tmplist), 2, 100);
  gtk_clist_set_column_width (GTK_CLIST (tmplist), 3, 80);


  label6 = gtk_label_new ("Waypoint Name");
  gtk_object_set_data (GTK_OBJECT (Mapper), "label6", label6);
  gtk_widget_show (label6);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 0, label6);
  gtk_widget_set_usize (label6, 236, -1);

  label7 = gtk_label_new ("Latitude");
  gtk_object_set_data (GTK_OBJECT (Mapper), "label7", label7);
  gtk_widget_show (label7);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 1, label7);

  label8 = gtk_label_new ("Longitude");
  gtk_object_set_data (GTK_OBJECT (Mapper), "label8", label8);
  gtk_widget_show (label8);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 2, label8);

  label9 = gtk_label_new ("Position Format");
  gtk_object_set_data (GTK_OBJECT (Mapper), "label9", label9);
  gtk_widget_show (label9);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 3, label9);
  gtk_signal_connect(GTK_OBJECT(clist3), "select_row",
		     GTK_SIGNAL_FUNC(selection_made),
		     NULL);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (Mapper), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (notebook2), hbox1);		  
  hpaned3 = gtk_hpaned_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "hpaned3", hpaned3);
  gtk_widget_show (hpaned3);
  gtk_box_pack_start (GTK_BOX (hbox1), hpaned3, TRUE, TRUE, 0);

  frame8 = gtk_frame_new (NULL);
  gtk_object_set_data (GTK_OBJECT (Mapper), "frame8", frame8);
  gtk_widget_show (frame8);
  gtk_container_add (GTK_CONTAINER (hpaned3), frame8);

  packer11 = gtk_packer_new ();
  gtk_object_set_data (GTK_OBJECT (Mapper), "packer11", packer11);
  gtk_widget_show (packer11);
  gtk_container_add (GTK_CONTAINER (frame8), packer11);
  
  
  gtk_packer_add (GTK_PACKER (packer11), combo6, GTK_SIDE_TOP,
                  GTK_ANCHOR_CENTER, GTK_FILL_X,
                  2, 0, 0, 0, 0); 

  /* start of scrollable text window */
  scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (Mapper), "scrolledwindow",
		       scrolledwindow);
  gtk_widget_show (scrolledwindow);
  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (Mapper), "hbox2", hbox2);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (hbox2), scrolledwindow);
  gtk_packer_add (GTK_PACKER (packer11), hbox2, 
  		  GTK_SIDE_TOP,  GTK_ANCHOR_WEST, 
  		  GTK_FILL_X| GTK_EXPAND |GTK_FILL_Y, 0, 0, 0, 0,0);
  text2 = gtk_text_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (Mapper), "text2", text2);
  gtk_widget_set_usize (text2, 450,300);
 
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolledwindow),
					text2);
 
  gtk_text_set_editable (GTK_TEXT (text2), FALSE);
  gtk_text_set_word_wrap(GTK_TEXT (text2), TRUE);

  gtk_widget_show (text2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow),
				   GTK_POLICY_ALWAYS, GTK_POLICY_AUTOMATIC);
       
  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (Mapper), "scrolledwindow2",
		       scrolledwindow2);
  gtk_widget_show (scrolledwindow2);
  gtk_container_add (GTK_CONTAINER (hpaned3), scrolledwindow2);

  drawingarea2 = gtk_drawing_area_new ();
 
  gtk_object_set_data (GTK_OBJECT (Mapper), "drawingarea2", drawingarea2);
  gtk_widget_show (drawingarea2);
 
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolledwindow2),
					drawingarea2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 /* Signals used to handle backing pixmap */
  gtk_signal_connect(GTK_OBJECT(drawingarea2), "expose_event",
		    (GtkSignalFunc) expose_event,
		     NULL);
  gtk_signal_connect(GTK_OBJECT(drawingarea2), "configure_event",
		    (GtkSignalFunc) configure_event,
		     NULL);
 
 /* Event signals */
  gtk_signal_connect(GTK_OBJECT(drawingarea2), "motion_notify_event",
		    (GtkSignalFunc) motion_notify_event,
		     NULL);
    
  gtk_signal_connect(GTK_OBJECT(drawingarea2), "button_press_event",
		    (GtkSignalFunc) button_press_event,
		     (gpointer) Mapper);

  gtk_signal_connect(GTK_OBJECT(drawingarea2), "button_release_event",
		    (GtkSignalFunc) button_release_event,
		     (gpointer) Mapper);

  gtk_widget_set_events (drawingarea2, GDK_EXPOSURE_MASK
			 | GDK_LEAVE_NOTIFY_MASK
			 | GDK_BUTTON_PRESS_MASK
			 | GDK_BUTTON_RELEASE_MASK
			 | GDK_POINTER_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);

  hbox=gtk_hbox_new( FALSE,0);
  		    
 
  /* create area to show slected color */
  colorarea = gtk_drawing_area_new ();
  gtk_box_pack_start(GTK_BOX(hbox),colorarea,0,0,0);
  gtk_widget_show (hbox);
  gtk_packer_add (GTK_PACKER (packer11), hbox, GTK_SIDE_TOP,
                  GTK_ANCHOR_CENTER, GTK_FILL_X,
                  2, 0, 0, 0, 0);
  gtk_object_set_data (GTK_OBJECT (Mapper), "colorarea", colorarea);
  gtk_widget_set_usize (colorarea,10,24);
  gtk_widget_show (colorarea);
  label16 = gtk_label_new (" Color Bucket");
  gtk_object_set_data (GTK_OBJECT (Mapper), "label16", label16);
  gtk_widget_show (label9);
  gtk_box_pack_start(GTK_BOX(hbox),label16,0,0,0);

 
  g_snprintf( buff, 20, "Welcome to g3DGMV");
 
  gnome_appbar_push((GnomeAppBar *) statusbar3,buff);

  progress_bar= (GtkWidget *)gnome_appbar_get_progress((GnomeAppBar*)statusbar3);

  gtk_object_set_data (GTK_OBJECT (Mapper), "progress_bar", progress_bar);


  gtk_widget_set_usize (progress_bar, 200, 24);
  Lmap1 = gtk_label_new("Map Entry");
  gtk_widget_show(Lmap1);
  set_notebook_tab(notebook2,0,Lmap1);
  Lmap2 = gtk_label_new("Map Log");
  gtk_widget_show(Lmap2);
  set_notebook_tab(notebook2,1,Lmap2);
  Lmap3 = gtk_label_new("Map Viewer");
  gtk_widget_show(Lmap3);
  set_notebook_tab(notebook2,2,Lmap3); 
  gtk_notebook_set_page(GTK_NOTEBOOK (notebook2), 2);
  
 
  Map = gtk_create_Elevmap();

  Map->pbar=progress_bar;

  app_list = g_slist_prepend(app_list, Mapper);

  return Mapper;
}


void       
Mapper_app_close(GtkWidget* app)
{
  g_return_if_fail(GNOME_IS_APP(app));

  app_list = g_slist_remove(app_list, app);

  gtk_widget_destroy(app);

  if (app_list == NULL)
    {
      /* No windows remaining */
      gtk_main_quit();
    }
}

GtkWidget*
create_fileselection1 ()
{
  GtkWidget *fileselection1;
  GtkWidget *ok_button2;
  GtkWidget *cancel_button2;

  fileselection1 = gtk_file_selection_new ("Select File");
  gtk_object_set_data (GTK_OBJECT (fileselection1), "fileselection1",
		       fileselection1);
  gtk_container_border_width (GTK_CONTAINER (fileselection1), 10);

  ok_button2 = GTK_FILE_SELECTION (fileselection1)->ok_button;
  gtk_object_set_data (GTK_OBJECT (fileselection1), "ok_button2", ok_button2);
  gtk_widget_show (ok_button2);
  GTK_WIDGET_SET_FLAGS (ok_button2, GTK_CAN_DEFAULT);

  cancel_button2 = GTK_FILE_SELECTION (fileselection1)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (fileselection1), "cancel_button2", 
		       cancel_button2);
  gtk_widget_show (cancel_button2);
  GTK_WIDGET_SET_FLAGS (cancel_button2, GTK_CAN_DEFAULT);

  return fileselection1;
}


GtkWidget*
create_colorselectiondialog1 ()
{
  GtkWidget *colorselectiondialog1;
  GtkWidget *ok_button3;
  GtkWidget *cancel_button3;
  GtkWidget *help_button1;

  colorselectiondialog1 = gtk_color_selection_dialog_new ("Select Color");
  gtk_object_set_data (GTK_OBJECT (colorselectiondialog1), "colorselectiondialog1", colorselectiondialog1);
  gtk_container_border_width (GTK_CONTAINER (colorselectiondialog1), 10);

  ok_button3 = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog1)->ok_button;
  gtk_object_set_data (GTK_OBJECT (colorselectiondialog1), "ok_button3", ok_button3);
  gtk_widget_show (ok_button3);
  GTK_WIDGET_SET_FLAGS (ok_button3, GTK_CAN_DEFAULT);

  cancel_button3 = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog1)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (colorselectiondialog1), "cancel_button3", cancel_button3);
  gtk_widget_show (cancel_button3);
  GTK_WIDGET_SET_FLAGS (cancel_button3, GTK_CAN_DEFAULT);

  help_button1 = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog1)->help_button;
  gtk_object_set_data (GTK_OBJECT (colorselectiondialog1), "help_button1", help_button1);
  gtk_widget_show (help_button1);
  GTK_WIDGET_SET_FLAGS (help_button1, GTK_CAN_DEFAULT);

  return colorselectiondialog1;
}


/*
 *create_dialog_bar
 */

GtkWidget*
create_dialog_bar ()
{
  GtkWidget *dialog_bar;
  GtkWidget *dialog_vbox2;
  GtkWidget *progressbar3;
  GtkWidget *dialog_action_area1;
  GtkWidget *label1;


  dialog_bar = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_bar), "dialog_bar", dialog_bar);
  GTK_WINDOW(dialog_bar)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_title (GTK_WINDOW (dialog_bar), "progressbar");
  //gtk_window_position (GTK_WINDOW (dialog_bar), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (dialog_bar), TRUE, TRUE, FALSE);

  dialog_vbox2 = GTK_DIALOG (dialog_bar)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog_bar), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  progressbar3 = gtk_progress_bar_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_bar), "progressbar3", progressbar3);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2),progressbar3 , TRUE, TRUE, 0);
  gtk_widget_show (progressbar3);
  
  gtk_widget_set_usize (progressbar3, 210, 24);

  dialog_action_area1 = GTK_DIALOG (dialog_bar)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog_bar), "dialog_action_area1", 
		       dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 2);

  label1 = gtk_label_new ("Loading File");
  gtk_object_set_data (GTK_OBJECT (dialog_bar), "label1", label1);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), label1, TRUE, TRUE, 0);
 
  return dialog_bar;
}

